----------------------------------
-- Variables
----------------------------------
local LAM = LibStub('LibAddonMenu-1.0')
local TCS =
{
	-- AddOn's Controller
	control = nil,
	labelControl = nil,
	
	-- Constants
	NAME 			= "TsCombatStats",
	SV 				= "TCS_SV_r4",
	
	TOOLTIP_FONT	= "ZoFontWinH4",
	
	-- AddOn Settings
	settingsMenu 	= nil,
	settings 		= 
	{
		chatTabOptions 		= {},
		abilityStatistics 	= {},
		
		abilityStatisticOptions =
		{
			enableTooltip 		= true,
			
			showNormalAverage 	= true,
			showNormalMaximum 	= true,
			showNormalMinimum 	= true,
			
			showCriticalAverage = true,
			showCriticalMaximum = true,
			showCriticalMinimum = true,
			
			showTotalAverage	= true,
			showCriticalPercent = true
		},
		
		alliancePointsMinimum 					= 5,
		enableCombatSessionDisplay				= true,
		showDPS									= true,
		totalDamage								= true,
		showHPS									= true,
		totalHealing							= true,
		combatSessionDisplayBGType				= "",
		combatSessionDisplayScale				= 1,
		combatSessionDisplayBGTransparency 		= 100,
		combatSessionDisplayTextTransparency 	= 100,
		
		combatSessionDPSDisplayPoint			= BOTTOM,
		combatSessionDPSDisplayRelativeTo		= GuiRoot,
		combatSessionDPSDisplayRelativePoint	= BOTTOM,
		combatSessionDPSDisplayOffsetX			= -70,
		combatSessionDPSDisplayOffsetY			= -73,
		
		combatSessionTotalDamageDisplayPoint			= BOTTOM,
		combatSessionTotalDamageDisplayRelativeTo		= GuiRoot,
		combatSessionTotalDamageDisplayRelativePoint	= BOTTOM,
		combatSessionTotalDamageDisplayOffsetX			= -210,
		combatSessionTotalDamageDisplayOffsetY			= -73,

		combatSessionHPSDisplayPoint			= BOTTOM,
		combatSessionHPSDisplayRelativeTo		= GuiRoot,
		combatSessionHPSDisplayRelativePoint	= BOTTOM,
		combatSessionHPSDisplayOffsetX			= 70,
		combatSessionHPSDisplayOffsetY			= -73,
		
		combatSessionTotalHealingDisplayPoint			= BOTTOM,
		combatSessionTotalHealingDisplayRelativeTo		= GuiRoot,
		combatSessionTotalHealingDisplayRelativePoint	= BOTTOM,
		combatSessionTotalHealingDisplayOffsetX			= 210,
		combatSessionTotalHealingDisplayOffsetY			= -73,
		
		combatSessionAbilityDamageEnableBarIndicators 	= true,
		combatSessionAbilityDamageBarWidth 				= 15,
		combatSessionAbilityDamageBarR 					= 0.8039,
		combatSessionAbilityDamageBarG 					= 0.0862,
		combatSessionAbilityDamageBarB 					= 0.0862,
		combatSessionAbilityDamageBarAlignment 			= "",
		combatSessionAbilityDamageEnablePercentage 		= true,
		combatSessionAbilityDamagePercentageSize 		= 1,
		combatSessionAbilityDamagePercentageAlignment 	= "",
	},
	
	-- Handler Backups
	handlerBackups =
	{
		control																						= {},
		abilityTooltip 																				= {},
		skillTooltip 																				= {},
		zo_chatOptionsDialog 																		= {},
		ZO_Skills 																					= {},
		TCS_Combat_Session_DPS_Display 																= {},
		TCS_Combat_Session_Total_Damage_Display														= {},
		TCS_Combat_Session_HPS_Display																= {},
		TCS_Combat_Session_Total_Healing_Display													= {},
		TCS_SettingsMenu_BG_Type_Combat_Session_Display_Dropdown									= {},
		TCS_SettingsMenu_BG_Type_Combat_Session_Display_DropdownDropdown							= {},
		TCS_SettingsMenu_Scale_Combat_Session_Display_Slider										= {},
		TCS_SettingsMenu_Scale_Combat_Session_Display_SliderSlider									= {},
		TCS_SettingsMenu_BG_Transparency_Combat_Session_Display_Slider								= {},
		TCS_SettingsMenu_BG_Transparency_Combat_Session_Display_SliderSlider						= {},
		TCS_SettingsMenu_Text_Transparency_Combat_Session_Display_Slider							= {},
		TCS_SettingsMenu_Text_Transparency_Combat_Session_Display_SliderSlider						= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Bar_Indicators_Checkbox					= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Bar_Indicators_CheckboxCheckbox			= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Width_Slider						= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Width_SliderSlider					= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Alignment_Dropdown					= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Alignment_DropdownDropdown			= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Color_Colorpicker					= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Percentage_Indicators_Checkbox				= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Percentage_Indicators_CheckboxCheckbox		= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Size_Slider					= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Size_SliderSlider			= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Alignment_Dropdown			= {},
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Alignment_DropdownDropdown	= {},
	},
	
	-- Localized Strings
	localizedStrings =
	{
		DAMAGE_BLOCKED						= "SI_TCS_DAMAGE_BLOCKED",
		DAMAGE_FALL							= "SI_TCS_ACTION_DAMAGE_FALL",
		
		DAMAGE_DEALT 						= "SI_TCS_DAMAGE_DEALT",
		DAMAGE_DEALT_PLAYER 				= "SI_TCS_DAMAGE_DEALT_PLAYER",
		DAMAGE_DEALT_CRITICAL				= "SI_TCS_DAMAGE_DEALT_CRITICAL",
		DAMAGE_DEALT_CRITICAL_PLAYER		= "SI_TCS_DAMAGE_DEALT_CRITICAL_PLAYER",
		
		DAMAGE_TAKEN						= "SI_TCS_DAMAGE_TAKEN",
		DAMAGE_TAKEN_PLAYER					= "SI_TCS_DAMAGE_TAKEN_PLAYER",
		DAMAGE_TAKEN_SELF					= "SI_TCS_DAMAGE_TAKEN_SELF",
		DAMAGE_TAKEN_CRITICAL 				= "SI_TCS_DAMAGE_TAKEN_CRITICAL",
		DAMAGE_TAKEN_CRITICAL_PLAYER		= "SI_TCS_DAMAGE_TAKEN_CRITICAL_PLAYER",
		DAMAGE_TAKEN_CRITICAL_SELF 			= "SI_TCS_DAMAGE_TAKEN_CRITICAL_SELF",
		
		HEALING_DONE 						= "SI_TCS_HEALING_DONE",
		HEALING_DONE_PLAYER 				= "SI_TCS_HEALING_DONE_PLAYER",
		HEALING_DONE_CRITICAL 				= "SI_TCS_HEALING_DONE_CRITICAL",
		HEALING_DONE_CRITICAL_PLAYER 		= "SI_TCS_HEALING_DONE_CRITICAL_PLAYER",
		
		HEALING_RECEIVED 					= "SI_TCS_HEALING_RECEIVED",
		HEALING_RECEIVED_SELF				= "SI_TCS_HEALING_RECEIVED_SELF",
		HEALING_RECEIVED_PLAYER 			= "SI_TCS_HEALING_RECEIVED_PLAYER",
		HEALING_RECEIVED_CRITICAL			= "SI_TCS_HEALING_RECEIVED_CRITICAL",
		HEALING_RECEIVED_CRITICAL_PLAYER	= "SI_TCS_HEALING_RECEIVED_CRITICAL_PLAYER",
		HEALING_RECEIVED_CRITICAL_SELF		= "SI_TCS_HEALING_RECEIVED_CRITICAL_SELF",
		
		COMBAT_EXPERIENCE 					= "SI_TCS_COMBAT_EXPERIENCE",
		COMBAT_NO_EXPERIENCE				= "SI_TCS_COMBAT_NO_EXPERIENCE",
		ABILITY_EXPERIENCE					= "SI_TCS_ABILITY_EXPERIENCE",
		SKILL_LINE_EXPERIENCE 				= "SI_TCS_SKILL_LINE_EXPERIENCE",
		FINESSE_EXPERIENCE					= "SI_TCS_FINESSE_EXPERIENCE",
		
		BUFF_STATUS_GAIN					= "SI_TCS_BUFF_STATUS_GAIN",
		BUFF_STATUS_LOOSE					= "SI_TCS_BUFF_STATUS_LOOSE",
		DEBUFF_STATUS_GAIN					= "SI_TCS_DEBUFF_STATUS_GAIN",
		DEBUFF_STATUS_LOOSE					= "SI_TCS_DEBUFF_STATUS_LOOSE",
		EFFECT_STATUS_GAIN					= "SI_TCS_EFFECT_STATUS_GAIN",
		EFFECT_STATUS_LOOSE					= "SI_TCS_EFFECT_STATUS_LOOSE",
		
		VETERAN_POINTS						= "SI_TCS_VETERAN_POINTS",
		ALLIANCE_POINTS						= "SI_TCS_ALLIANCE_POINTS",
		
		FINESSE_PROGRESSION					= "SI_TCS_FINESSE_PROGRESSION",
		FINESSE_PROGRESSION_NOXP			= "SI_TCS_FINESSE_PROGRESSION_NOXP",
		FINESSE_PROGRESSION_LOOT 			= "SI_TCS_FINESSE_PROGRESSION_LOOT",
		FINESSE_PROGRESSION_LOOT_NOXP 		= "SI_TCS_FINESSE_PROGRESSION_LOOT_NOXP",
		
		COMBAT_START 						= "SI_TCS_COMBAT_START",
		COMBAT_END 							= "SI_TCS_COMBAT_END",
		
		GENERIC_DAMAGE 						= "SI_TCS_GENERIC_DAMAGE",
		GENERIC_AVERAGE 					= "SI_TCS_GENERIC_AVERAGE",
		GENERIC_MAXIMUM 					= "SI_TCS_GENERIC_MAXIMUM",
		GENERIC_MINIMUM 					= "SI_TCS_GENERIC_MINIMUM",
		GENERIC_AVERAGE_CRITICAL 			= "SI_TCS_GENERIC_AVERAGE_CRITICAL",
		GENERIC_MAXIMUM_CRITICAL 			= "SI_TCS_GENERIC_MAXIMUM_CRITICAL",
		GENERIC_MINIMUM_CRITICAL 			= "SI_TCS_GENERIC_MINIMUM_CRITICAL",
		GENERIC_TOTAL_AVERAGE				= "SI_TCS_GENERIC_TOTAL_AVERAGE",
		GENERIC_CRITICAL_CHANCE 			= "SI_TCS_GENERIC_CRITICAL_CHANCE",
		GENERIC_NODATA						= "SI_TCS_GENERIC_NODATA",
		
		GENERIC_DPS							= "SI_TCS_GENERIC_DPS",
		GENERIC_HPS							= "SI_TCS_GENERIC_HPS",
		
		SETTINGS_TOOLTIP_LABEL 				= "SI_TCS_SETTINGS_TOOLTIP_LABEL",
		SETTINGS_TOOLTIP_ENABLE_LABEL		= "SI_TCS_SETTINGS_TOOLTIP_ENABLE_LABEL",
		SETTINGS_TOOLTIP_ENABLE_TOOLTIP		= "SI_TCS_SETTINGS_TOOLTIP_ENABLE_TOOLTIP",
		SETTINGS_AVERAGE_LABEL 				= "SI_TCS_SETTINGS_AVERAGE_LABEL",
		SETTINGS_AVERAGE_TOOLTIP 			= "SI_TCS_SETTINGS_AVERAGE_TOOLTIP",
		SETTINGS_MAXIMUM_LABEL 				= "SI_TCS_SETTINGS_MAXIMUM_LABEL",
		SETTINGS_MAXIMUM_TOOLTIP 			= "SI_TCS_SETTINGS_MAXIMUM_TOOLTIP",
		SETTINGS_MINIMUM_LABEL 				= "SI_TCS_SETTINGS_MINIMUM_LABEL",
		SETTINGS_MINIMUM_TOOLTIP 			= "SI_TCS_SETTINGS_MINIMUM_TOOLTIP",
		SETTINGS_CRITICAL_AVERAGE_LABEL 	= "SI_TCS_SETTINGS_CRITICAL_AVERAGE_LABEL",
		SETTINGS_CRITICAL_AVERAGE_TOOLTIP 	= "SI_TCS_SETTINGS_CRITICAL_AVERAGE_TOOLTIP",
		SETTINGS_CRITICAL_MAXIMUM_LABEL 	= "SI_TCS_SETTINGS_CRITICAL_MAXIMUM_LABEL",
		SETTINGS_CRITICAL_MAXIMUM_TOOLTIP 	= "SI_TCS_SETTINGS_CRITICAL_MAXIMUM_TOOLTIP",
		SETTINGS_CRITICAL_MINIMUM_LABEL 	= "SI_TCS_SETTINGS_CRITICAL_MINIMUM_LABEL",
		SETTINGS_CRITICAL_MINIMUM_TOOLTIP 	= "SI_TCS_SETTINGS_CRITICAL_MINIMUM_TOOLTIP",
		SETTINGS_TOTAL_AVERAGE_LABEL		= "SI_TCS_SETTINGS_TOTAL_AVERAGE_LABEL",
		SETTINGS_TOTAL_AVERAGE_TOOLTIP		= "SI_TCS_SETTINGS_TOTAL_AVERAGE_TOOLTIP",
		SETTINGS_CRITICAL_PERCENT_LABEL 	= "SI_TCS_SETTINGS_CRITICAL_PERCENT_LABEL",
		SETTINGS_CRITICAL_PERCENT_TOOLTIP 	= "SI_TCS_SETTINGS_CRITICAL_PERCENT_TOOLTIP",
		
		TYPE_DAMAGE			= "SI_TCS_TYPE_DAMAGE",
		TYPE_HEALING		= "SI_TCS_TYPE_HEALING",
		
		SETTINGS_COMBAT_LOGGING_LABEL 		= "SI_TCS_SETTINGS_COMBAT_LOGGING_LABEL",
		SETTINGS_ALLIANCE_POINTS_LABEL		= "SI_TCS_SETTINGS_ALLIANCE_POINTS_LABEL",
		SETTINGS_ALLIANCE_POINTS_TOOLTIP	= "SI_TCS_SETTINGS_ALLIANCE_POINTS_TOOLTIP",
		
		SETTINGS_COMBAT_SESSION_DISPLAY_GUI							= "SI_TCS_SETTINGS_COMBAT_SESSION_DISPLAY_GUI",
		SETTINGS_COMBAT_SESSION_DISPLAY_ENABLE_LABEL				= "SI_TCS_SETTINGS_COMBAT_SESSION_DISPLAY_ENABLE_LABEL",
		SETTINGS_COMBAT_SESSION_DISPLAY_ENABLE_TOOLTIP				= "SI_TCS_SETTINGS_COMBAT_SESSION_DISPLAY_ENABLE_TOOLTIP",
		SETTINGS_DPS_SHOW_LABEL										= "SI_TCS_SETTINGS_DPS_SHOW_LABEL",
		SETTINGS_DPS_SHOW_TOOLTIP									= "SI_TCS_SETTINGS_DPS_SHOW_TOOLTIP",
		SETTINGS_DAMAGE_TOTAL_LABEL									= "SI_TCS_SETTINGS_DAMAGE_TOTAL_LABEL",
		SETTINGS_DAMAGE_TOTAL_TOOLTIP								= "SI_TCS_SETTINGS_DAMAGE_TOTAL_TOOLTIP",
		SETTINGS_HPS_SHOW_LABEL										= "SI_TCS_SETTINGS_HPS_SHOW_LABEL",
		SETTINGS_HPS_SHOW_TOOLTIP									= "SI_TCS_SETTINGS_HPS_SHOW_TOOLTIP",
		SETTINGS_HEAL_TOTAL_SHOW_LABEL								= "SI_TCS_SETTINGS_HEAL_TOTAL_SHOW_LABEL",
		SETTINGS_HEAL_TOTAL_TOOLTIP									= "SI_TCS_SETTINGS_HEAL_TOTAL_TOOLTIP",
		SETTINGS_BACKGROUND_TYPE_LABEL								= "SI_TCS_SETTINGS_BACKGROUND_TYPE_LABEL",
		SETTINGS_BACKGROUND_TYPE_TOOLTIP							= "SI_TCS_SETTINGS_BACKGROUND_TYPE_TOOLTIP",
		SETTINGS_BACKGROUND_TYPE_A									= "SI_TCS_SETTINGS_BACKGROUND_TYPE_A",
		SETTINGS_BACKGROUND_TYPE_B									= "SI_TCS_SETTINGS_BACKGROUND_TYPE_B",
		SETTINGS_BACKGROUND_TYPE_NONE								= "SI_TCS_SETTINGS_BACKGROUND_TYPE_NONE",
		SETTINGS_COMBAT_SESSION_DISPLAY_SCALE_LABEL					= "SI_TCS_SETTINGS_COMBAT_SESSION_DISPLAY_SCALE_LABEL",
		SETTINGS_COMBAT_SESSION_DISPLAY_SCALE_TOOLTIP				= "SI_TCS_SETTINGS_COMBAT_SESSION_DISPLAY_SCALE_TOOLTIP",
		SETTINGS_COMBAT_SESSION_DISPLAY_BG_TRANSPARENCY_LABEL		= "SI_TCS_SETTINGS_COMBAT_SESSION_DISPLAY_BG_TRANSPARENCY_LABEL",
		SETTINGS_COMBAT_SESSION_DISPLAY_BG_TRANSPARENCY_TOOLTIP 	= "SI_TCS_SETTINGS_COMBAT_SESSION_DISPLAY_BG_TRANSPARENCY_TOOLTIP",
		SETTINGS_COMBAT_SESSION_DISPLAY_TEXT_TRANSPARENCY_LABEL		= "SI_TCS_SETTINGS_COMBAT_SESSION_DISPLAY_TEXT_TRANSPARENCY_LABEL",
		SETTINGS_COMBAT_SESSION_DISPLAY_TEXT_TRANSPARENCY_TOOLTIP 	= "SI_TCS_SETTINGS_COMBAT_SESSION_DISPLAY_TEXT_TRANSPARENCY_TOOLTIP",
		
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_LABEL = "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_LABEL",
		
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_ALIGNMENT_LEFT	= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_ALIGNMENT_LEFT",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_ALIGNMENT_RIGHT	= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_ALIGNMENT_RIGHT",

		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_CENTER		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_CENTER",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOP			= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOP",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOM		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOM",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOPRIGHT		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOPRIGHT",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOPLEFT		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOPLEFT",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOMRIGHT	= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOMRIGHT",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOMLEFT	= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOMLEFT",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_RIGHT		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_RIGHT",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_LEFT			= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_LEFT",

		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_BAR_INDICATORS_LABEL			= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_BAR_INDICATORS_LABEL",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_BAR_INDICATORS_TOOLTIP		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_BAR_INDICATORS_TOOLTIP",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_WIDTH_LABEL			= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_WIDTH_LABEL",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_WIDTH_TOOLTIP		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_WIDTH_TOOLTIP",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_ALIGNMENT_LABEL		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_ALIGNMENT_LABEL",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_ALIGNMENT_TOOLTIP	= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_ALIGNMENT_TOOLTIP",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_COLOR_LABEL			= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_COLOR_LABEL",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_COLOR_TOOLTIP		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_COLOR_TOOLTIP",

		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_PERCENTAGE_INDICATORS_LABEL		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_PERCENTAGE_INDICATORS_LABEL",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_PERCENTAGE_INDICATORS_TOOLTIP	= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_PERCENTAGE_INDICATORS_TOOLTIP",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_SIZE_LABEL		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_SIZE_LABEL",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_SIZE_TOOLTIP		= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_SIZE_TOOLTIP",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_ALIGNMENT_LABEL	= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_ALIGNMENT_LABEL",
		SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_ALIGNMENT_TOOLTIP	= "SI_TCS_SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_ALIGNMENT_TOOLTIP",
		
		SETTINGS_GLOBAL_LABEL		= "SI_TCS_SETTINGS_GLOBAL_LABEL",
		SETTINGS_RESET_ALL_LABEL	= "SI_TCS_SETTINGS_RESET_ALL_LABEL",
		SETTINGS_RESET_ALL_TOOLTIP 	= "SI_TCS_SETTINGS_RESET_ALL_TOOLTIP",
		
		SETTINGS_RESET = "SI_TCS_SETTINGS_RESET",
		
		FILTER_DAMAGE_DEALT 			= "SI_TCS_FILTER_DAMAGE_DEALT",
		FILTER_DAMAGE_RECEIVED 			= "SI_TCS_FILTER_DAMAGE_RECEIVED",
		FILTER_HEALING_DONE 			= "SI_TCS_FILTER_HEALING_DONE",
		FILTER_HEALING_RECEIVED 		= "SI_TCS_FILTER_HEALING_RECEIVED",
		FILTER_COMBAT_EXPERIENCE 		= "SI_TCS_FILTER_COMBAT_EXPERIENCE",
		FILTER_FINESSE_EXPERIENCE 		= "SI_TCS_FILTER_FINESSE_EXPERIENCE",
		FILTER_SKILL_LINE_EXPERIENCE 	= "SI_TCS_FILTER_SKILL_LINE_EXPERIENCE",
		FILTER_ABILITY_EXPERIENCE 		= "SI_TCS_FILTER_ABILITY_EXPERIENCE",
		FILTER_BUFF_STATUS 				= "SI_TCS_FILTER_BUFF_STATUS",
		FILTER_DEBUFF_STATUS 			= "SI_TCS_FILTER_DEBUFF_STATUS",
		FILTER_VETERAN_POINTS 			= "SI_TCS_FILTER_VETERAN_POINTS",
		FILTER_ALLIANCE_POINTS 			= "SI_TCS_FILTER_ALLIANCE_POINTS",
		FILTER_FINESSE_PROGRESSION 		= "SI_TCS_FILTER_FINESSE_PROGRESSION",
		FILTER_COMBAT_START_END 		= "SI_TCS_FILTER_COMBAT_START_END",
	},
	
	damageTypeStrings =
	{
		[DAMAGE_TYPE_COLD] 		= "SI_TCS_DAMAGE_TYPE_COLD",
		[DAMAGE_TYPE_DISEASE] 	= "SI_TCS_DAMAGE_TYPE_DISEASE",
		[DAMAGE_TYPE_DROWN]		= "SI_TCS_DAMAGE_TYPE_DROWN",
		[DAMAGE_TYPE_EARTH] 	= "SI_TCS_DAMAGE_TYPE_EARTH",
		[DAMAGE_TYPE_FIRE] 		= "SI_TCS_DAMAGE_TYPE_FIRE",
		[DAMAGE_TYPE_GENERIC] 	= "SI_TCS_DAMAGE_TYPE_GENERIC",
		[DAMAGE_TYPE_MAGIC] 	= "SI_TCS_DAMAGE_TYPE_MAGIC",
		[DAMAGE_TYPE_NONE] 		= "SI_TCS_DAMAGE_TYPE_NONE",
		[DAMAGE_TYPE_OBLIVION] 	= "SI_TCS_DAMAGE_TYPE_OBLIVION",
		[DAMAGE_TYPE_PHYSICAL]	= "SI_TCS_DAMAGE_TYPE_PHYSICAL",
		[DAMAGE_TYPE_POISON] 	= "SI_TCS_DAMAGE_TYPE_POISON",
		[DAMAGE_TYPE_SHOCK] 	= "SI_TCS_DAMAGE_TYPE_SHOCK",
	},

	-- Last MouseOver
	lastMouseOver 				= nil,
	
	-- Skill/Ability Cache
	abilityInfoCache = {},
	
	-- Combat session
	isInCombat = false,
	
	combatSessionStartTime = 0,

	combatSessionSkillAbilityExperienceGained = {},
	combatSessionAbilityDamage = {},
	
	combatSessionDPSDisplay 			= nil,
	combatSessionTotalDamageDisplay 	= nil,
	combatSessionHPSDisplay 			= nil,
	combatSessionTotalHealingDisplay 	= nil,
	
	combatSessionExperiencedGained 					= 0,
	combatSessionFinesseBonusExperiencePercentage 	= 0,
	
	combatSessionDamageDealt 	= 0,
	combatSessionHealingDone 	= 0,
	
	-- Misc vars
	chatTabFilterCount			= 0,
	chatTabFilterRowCount 		= 0,
	chatTabFilterColumnCount	= 0,
	
	toolTipInitializeCounter 	= 0,
	lastExperiences 			= {},
	onlyEnable					= false,

	abilityNameProxies = {},
	slotNameCache = {},
}

----------------------------------
-- Helpers
----------------------------------
local function round( num, idp )
  local mult = 10 ^ ( idp or 0 )
  return math.floor( num * mult + 0.5 ) / mult
end

----------------------------------
-- Core
----------------------------------
function TCS_Initialize( _control )
	TCS.control = _control
	TCS:OnInitialized()
end

function TCS:OnInitialized()
	-- Register events
	EVENT_MANAGER:RegisterForEvent( self.NAME, EVENT_ADD_ON_LOADED, function( ... ) self:OnEventAddOnLoaded( ... ) end )
end

function TCS:OnEventAddOnLoaded( _event, _addonName )
	-- If the addon is not ours, do nothing
	if( _addonName ~= self.NAME ) then
		return
	end
	
	-- Create a dummy label for the use of GetStringWidth()
	self.labelControl = WINDOW_MANAGER:CreateControl( self.NAME .. "DummyLabel", GuiRoot, CT_LABEL )
	self.labelControl:SetFont( self.TOOLTIP_FONT )
	self.labelControl:SetHidden( true )
	
	-- Initialize saved vars
	self.settings.combatSessionAbilityDamageBarAlignment = GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_ALIGNMENT_LEFT ] )
	self.settings.combatSessionAbilityDamagePercentageAlignment = GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOMLEFT ] )
	self.settings.combatSessionDisplayBGType = GetString( _G[ self.localizedStrings.SETTINGS_BACKGROUND_TYPE_A ] )
	self.settings = ZO_SavedVars:New( self.SV, 1, nil, self.settings )

	-- Initialize GUI and Settings
	self:InitializeAddOnMenu()
	self:ChatTabOptionsIntialize()
	self:CombatSessionDisplayInitialize()
	self:ChatCombatOutputInitialize()
	self:SkillTooltipInitialize()
	self:InitializeAbilityDamagePercentages()
	
	-- Register handlers
	self:RegisterHandler(
		self.control, "OnUpdate",
		self.handlerBackups.control,
		function() self:OnUpdate() end
	)
	
	self:RegisterHandler(
		ZO_Skills, "OnHide",
		self.handlerBackups.ZO_Skills,
		function() self:HideCombatSessionDisplays( false ) end
	)
	
	self:RegisterHandler(
		ZO_Skills, "OnShow",
		self.handlerBackups.ZO_Skills,
		function() self:HideCombatSessionDisplays( true ) end
	)
	
	self:RegisterHandler(
		TCS_Combat_Session_DPS_Display, "OnMoveStop",
		self.handlerBackups.TCS_Combat_Session_DPS_Display,
		function()
			local isValidAnchor, point, relativeTo, relativePoint, offsetX, offsetY = TCS_Combat_Session_DPS_Display:GetAnchor(0)
			
			self.settings.combatSessionDPSDisplayPoint 			= point
			self.settings.combatSessionDPSDisplayRelativeTo		= relativeTo
			self.settings.combatSessionDPSDisplayRelativePoint	= relativePoint
			self.settings.combatSessionDPSDisplayOffsetX		= offsetX
			self.settings.combatSessionDPSDisplayOffsetY		= offsetY
					
		end
	)
	
	self:RegisterHandler(
		TCS_Combat_Session_Total_Damage_Display, "OnMoveStop",
		self.handlerBackups.TCS_Combat_Session_Total_Damage_Display,
		function()
			local isValidAnchor, point, relativeTo, relativePoint, offsetX, offsetY = TCS_Combat_Session_Total_Damage_Display:GetAnchor(0)
			
			self.settings.combatSessionTotalDamageDisplayPoint 			= point
			self.settings.combatSessionTotalDamageDisplayRelativeTo		= relativeTo
			self.settings.combatSessionTotalDamageDisplayRelativePoint	= relativePoint
			self.settings.combatSessionTotalDamageDisplayOffsetX		= offsetX
			self.settings.combatSessionTotalDamageDisplayOffsetY		= offsetY
		end
	)
	
	self:RegisterHandler(
		TCS_Combat_Session_HPS_Display, "OnMoveStop",
		self.handlerBackups.TCS_Combat_Session_HPS_Display,
		function()
			local isValidAnchor, point, relativeTo, relativePoint, offsetX, offsetY = TCS_Combat_Session_HPS_Display:GetAnchor(0)
			
			self.settings.combatSessionHPSDisplayPoint 			= point
			self.settings.combatSessionHPSDisplayRelativeTo		= relativeTo
			self.settings.combatSessionHPSDisplayRelativePoint	= relativePoint
			self.settings.combatSessionHPSDisplayOffsetX		= offsetX
			self.settings.combatSessionHPSDisplayOffsetY		= offsetY
		end
	)
	
	self:RegisterHandler(
		TCS_Combat_Session_Total_Healing_Display, "OnMoveStop",
		self.handlerBackups.TCS_Combat_Session_Total_Healing_Display,
		function()
			local isValidAnchor, point, relativeTo, relativePoint, offsetX, offsetY = TCS_Combat_Session_Total_Healing_Display:GetAnchor(0)
			
			self.settings.combatSessionTotalHealingDisplayPoint 		= point
			self.settings.combatSessionTotalHealingDisplayRelativeTo	= relativeTo
			self.settings.combatSessionTotalHealingDisplayRelativePoint	= relativePoint
			self.settings.combatSessionTotalHealingDisplayOffsetX		= offsetX
			self.settings.combatSessionTotalHealingDisplayOffsetY		= offsetY
		end
	)
	
	-- Register chat commands
	SLASH_COMMANDS[ "/clear" ] =
		function( _param )
			if( _param == "all" ) then
				for i = 1, GetNumChatContainerTabs( 1 ), 1 do
					_G[ "ZO_ChatWindowTemplate" .. i .. "Buffer" ]:Clear()
				end
			else
				for i = 1, GetNumChatContainerTabs( 1 ), 1 do
					if( _G[ "ZO_ChatWindowTabTemplate" .. i ]:GetDrawLevel() == 2 ) then
						_G[ "ZO_ChatWindowTemplate" .. i .. "Buffer" ]:Clear()
					end
				end
			end
		end
		
	SLASH_COMMANDS[ "/tcs" ] =
		function( _param )
			if( _param == "reset" ) then
				self:ResetAll()
			end
		end
end

function TCS:RegisterHandler( _handler, _handlerName, _backupHandler, _callback )
	-- backup the existing handler if it exists,
	-- then set the new handler
	if( _handler:IsHandlerSet( _handlerName ) ) then
		_backupHandler[ _handlerName ] = _handler:GetHandler( _handlerName )
		
		_handler:SetHandler(
			_handlerName,
			function( ... )
				_backupHandler[ _handlerName ]( ... )
				_callback()
			end
		)
	else
		_handler:SetHandler(
			_handlerName,
			_callback
		)
	end
end

function TCS:InitializeAddOnMenu()
	-- Create the menu
	self.settingsMenu = LAM:CreateControlPanel( 'TCS_SettingsMenu', 'T\'s Combat Stats' )
		
	-- Header for the ability statistic
	LAM:AddHeader( TCS.settingsMenu, "TCS_SettingsMenu_AbilityStatisticTooltip", GetString( _G[ self.localizedStrings.SETTINGS_TOOLTIP_LABEL ] ) )
	
	local enable = LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox", 
		GetString( _G[ self.localizedStrings.SETTINGS_TOOLTIP_ENABLE_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_TOOLTIP_ENABLE_TOOLTIP ] ),
		function() return self.settings.abilityStatisticOptions.enableTooltip end,
		function( _set )
			self.settings.abilityStatisticOptions.enableTooltip	 		= _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( currentMouseOver == "TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox" or
				currentMouseOver == "TCS_SettingsMenu_AbilityStatistic_Enable_CheckboxCheckbox"
			) then
				if( self.settings.abilityStatisticOptions.showNormalAverage ~= _set ) 	then zo_callHandler( TCS_SettingsMenu_NormalAverage_Checkbox, 	"OnMouseUp" ) end
				if( self.settings.abilityStatisticOptions.showNormalMaximum ~= _set ) 	then zo_callHandler( TCS_SettingsMenu_NormalMaximum_Checkbox, 	"OnMouseUp" ) end
				if( self.settings.abilityStatisticOptions.showNormalMinimum ~= _set ) 	then zo_callHandler( TCS_SettingsMenu_NormalMinimum_Checkbox, 	"OnMouseUp" ) end
				if( self.settings.abilityStatisticOptions.showCriticalAverage ~= _set ) then zo_callHandler( TCS_SettingsMenu_CriticalAverage_Checkbox, "OnMouseUp" ) end
				if( self.settings.abilityStatisticOptions.showCriticalMaximum ~= _set ) then zo_callHandler( TCS_SettingsMenu_CriticalMaximum_Checkbox, "OnMouseUp" ) end
				if( self.settings.abilityStatisticOptions.showCriticalMinimum ~= _set ) then zo_callHandler( TCS_SettingsMenu_CriticalMinimum_Checkbox, "OnMouseUp" ) end
				if( self.settings.abilityStatisticOptions.showTotalAverage ~= _set ) 	then zo_callHandler( TCS_SettingsMenu_TotalAverage_Checkbox, 	"OnMouseUp" ) end
				if( self.settings.abilityStatisticOptions.showCriticalPercent ~= _set ) then zo_callHandler( TCS_SettingsMenu_CriticalPercent_Checkbox, "OnMouseUp" ) end
			end
		end,
		nil, nil
	)

	-- Normal damage
	LAM:AddCheckbox(
		TCS.settingsMenu,
		"TCS_SettingsMenu_NormalAverage_Checkbox", 
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_AVERAGE_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_AVERAGE_TOOLTIP ] ),
		function() return self.settings.abilityStatisticOptions.showNormalAverage end,
		function( _set )
			self.settings.abilityStatisticOptions.showNormalAverage = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.abilityStatisticOptions.enableTooltip and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox, "OnMouseUp" )
			end
		end,
		nil, nil
	)
	
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_NormalMaximum_Checkbox", 
		"          " .. GetString( _G[ self.localizedStrings.SETTINGS_MAXIMUM_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_MAXIMUM_TOOLTIP ] ),
		function() return self.settings.abilityStatisticOptions.showNormalMaximum end,
		function( _set )
			self.settings.abilityStatisticOptions.showNormalMaximum = _set 
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.abilityStatisticOptions.enableTooltip and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox, "OnMouseUp" )
			end
		end,
		nil, nil
	)
	
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_NormalMinimum_Checkbox", 
		"          " .. GetString( _G[ self.localizedStrings.SETTINGS_MINIMUM_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_MINIMUM_TOOLTIP ] ),
		function() return self.settings.abilityStatisticOptions.showNormalMinimum end,
		function( _set )
			self.settings.abilityStatisticOptions.showNormalMinimum = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.abilityStatisticOptions.enableTooltip and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox, "OnMouseUp" )
			end
		end,
		nil, nil
	)
	
	-- Critical Damage
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_CriticalAverage_Checkbox", 
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_CRITICAL_AVERAGE_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_CRITICAL_AVERAGE_TOOLTIP ] ),
		function() return self.settings.abilityStatisticOptions.showCriticalAverage end,
		function( _set )
			self.settings.abilityStatisticOptions.showCriticalAverage = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.abilityStatisticOptions.enableTooltip and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox, "OnMouseUp" )
			end
		end,
		nil, nil
	)
	
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_CriticalMaximum_Checkbox", 
		"          " .. GetString( _G[ self.localizedStrings.SETTINGS_CRITICAL_MAXIMUM_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_CRITICAL_MAXIMUM_TOOLTIP ] ),
		function() return self.settings.abilityStatisticOptions.showCriticalMaximum end,
		function( _set )
			self.settings.abilityStatisticOptions.showCriticalMaximum = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.abilityStatisticOptions.enableTooltip and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox, "OnMouseUp" )
			end
		end,
		nil, nil
	)
	
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_CriticalMinimum_Checkbox", 
		"          " .. GetString( _G[ self.localizedStrings.SETTINGS_CRITICAL_MINIMUM_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_CRITICAL_MINIMUM_TOOLTIP ] ),
		function() return self.settings.abilityStatisticOptions.showCriticalMinimum end,
		function( _set )
			self.settings.abilityStatisticOptions.showCriticalMinimum = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.abilityStatisticOptions.enableTooltip and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox, "OnMouseUp" )
			end
		end,
		nil, nil
	)
	
	-- Total Average
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_TotalAverage_Checkbox", 
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_TOTAL_AVERAGE_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_TOTAL_AVERAGE_TOOLTIP ] ),
		function() return self.settings.abilityStatisticOptions.showTotalAverage end,
		function( _set )
			self.settings.abilityStatisticOptions.showTotalAverage = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.abilityStatisticOptions.enableTooltip and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox, "OnMouseUp" )
			end
		end,
		nil, nil
	)
	
	-- Critical Percent
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_CriticalPercent_Checkbox", 
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_CRITICAL_PERCENT_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_CRITICAL_PERCENT_TOOLTIP ] ),
		function() return self.settings.abilityStatisticOptions.showCriticalPercent end,
		function( _set )
			self.settings.abilityStatisticOptions.showCriticalPercent = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.abilityStatisticOptions.enableTooltip and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_AbilityStatistic_Enable_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_AbilityStatistic_Enable_Checkbox, "OnMouseUp" )
			end
		end,
		nil, nil
	)
	
	-- Header for the combat logging
	LAM:AddDescription( TCS.settingsMenu, "TCS_SettingsMenu_CombatLogging_spacing", "" )
	LAM:AddHeader( TCS.settingsMenu, "TCS_SettingsMenu_CombatLogging", GetString( _G[ self.localizedStrings.SETTINGS_COMBAT_LOGGING_LABEL ] ) )

	-- Alliance Points
	LAM:AddSlider(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_AlliancePoints_Slider",
		GetString( _G[ self.localizedStrings.SETTINGS_ALLIANCE_POINTS_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_ALLIANCE_POINTS_TOOLTIP ] ),
		0, 100, 1,
		function() return self.settings.alliancePointsMinimum end,
		function( _set ) self.settings.alliancePointsMinimum = _set end,
		nil, nil
	)
	
	-- Header for the combat statistics display
	LAM:AddDescription( TCS.settingsMenu, "TCS_SettingsMenu_Combat_Session_Display_spacing", "" )
	LAM:AddHeader( TCS.settingsMenu, "TCS_SettingsMenu_Combat_Session_Display_GUI", GetString( _G[ self.localizedStrings.SETTINGS_COMBAT_SESSION_DISPLAY_GUI ] ) )
	
	-- Enable dps/hps element
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_Enable_Combat_Session_Display_Checkbox", 
		GetString( _G[ self.localizedStrings.SETTINGS_COMBAT_SESSION_DISPLAY_ENABLE_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_COMBAT_SESSION_DISPLAY_ENABLE_TOOLTIP ] ),
		function() return self.settings.enableCombatSessionDisplay end,
		function( _set )
			self.settings.enableCombatSessionDisplay = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( currentMouseOver == "TCS_SettingsMenu_Enable_Combat_Session_Display_Checkbox" or
				currentMouseOver == "TCS_SettingsMenu_Enable_Combat_Session_Display_CheckboxCheckbox"
			) then
				if( self.settings.showDPS ~= _set ) 		then zo_callHandler( TCS_SettingsMenu_Show_DPS_Checkbox, 			"OnMouseUp" ) end
				if( self.settings.totalDamage ~= _set ) 	then zo_callHandler( TCS_SettingsMenu_Show_Total_Damage_Checkbox, 	"OnMouseUp" ) end
				if( self.settings.showHPS ~= _set ) 		then zo_callHandler( TCS_SettingsMenu_Show_HPS_Checkbox, 			"OnMouseUp" ) end
				if( self.settings.totalHealing ~= _set ) 	then zo_callHandler( TCS_SettingsMenu_Total_Healing_Checkbox, 		"OnMouseUp" ) end
			end
		end,
		nil, nil
	)
	
	-- Show dps
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_Show_DPS_Checkbox", 
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_DPS_SHOW_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_DPS_SHOW_TOOLTIP ] ),
		function() return self.settings.showDPS end,
		function( _set )
			self.settings.showDPS = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.enableCombatSessionDisplay and
				currentMouseOver ~= "TCS_SettingsMenu_Enable_Combat_Session_Display_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_Enable_Combat_Session_Display_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_Enable_Combat_Session_Display_Checkbox, "OnMouseUp" )
			end

			self:SetCombatSessionDPSUpdateHidden()
		end,
		nil, nil
	)
	
	-- show total damage
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_Show_Total_Damage_Checkbox", 
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_DAMAGE_TOTAL_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_DAMAGE_TOTAL_TOOLTIP ] ),
		function() return self.settings.totalDamage end,
		function( _set )
			self.settings.totalDamage = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.enableCombatSessionDisplay and
				currentMouseOver ~= "TCS_SettingsMenu_Enable_Combat_Session_Display_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_Enable_Combat_Session_Display_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_Enable_Combat_Session_Display_Checkbox, "OnMouseUp" )
			end

			self:SetCombatSessionTotalDamageUpdateHidden()
		end,
		nil, nil
	)
	
	-- Show hps
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_Show_HPS_Checkbox", 
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_HPS_SHOW_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_HPS_SHOW_TOOLTIP ] ),
		function() return self.settings.showHPS end,
		function( _set )
			self.settings.showHPS = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.enableCombatSessionDisplay and
				currentMouseOver ~= "TCS_SettingsMenu_Enable_Combat_Session_Display_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_Enable_Combat_Session_Display_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_Enable_Combat_Session_Display_Checkbox, "OnMouseUp" )
			end

			self:SetCombatSessionHPSUpdateHidden()
		end,
		nil, nil
	)
	
	-- show total healing
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_Total_Healing_Checkbox", 
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_HEAL_TOTAL_SHOW_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_HEAL_TOTAL_TOOLTIP ] ),
		function() return self.settings.totalHealing end,
		function( _set )
			self.settings.totalHealing = _set
			
			local currentMouseOver = WINDOW_MANAGER:GetMouseOverControl():GetName()
			if( not self.settings.enableCombatSessionDisplay and
				currentMouseOver ~= "TCS_SettingsMenu_Enable_Combat_Session_Display_Checkbox" and
				currentMouseOver ~= "TCS_SettingsMenu_Enable_Combat_Session_Display_CheckboxCheckbox"
			) then
				zo_callHandler( TCS_SettingsMenu_Enable_Combat_Session_Display_Checkbox, "OnMouseUp" )
			end

			self:SetCombatSessionTotalHealingUpdateHidden()
		end,
		nil, nil
	)
	
	-- bg type
	LAM:AddDropdown(
		TCS.settingsMenu,
		"TCS_SettingsMenu_BG_Type_Combat_Session_Display_Dropdown",
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_BACKGROUND_TYPE_LABEL ] ),
		GetString( _G[ self.localizedStrings.SETTINGS_BACKGROUND_TYPE_TOOLTIP ] ),
		{
			GetString( _G[ self.localizedStrings.SETTINGS_BACKGROUND_TYPE_A ] ),
			GetString( _G[ self.localizedStrings.SETTINGS_BACKGROUND_TYPE_B ] ),
			GetString( _G[ self.localizedStrings.SETTINGS_BACKGROUND_TYPE_NONE ] )
		},
		function() return self.settings.combatSessionDisplayBGType end,
		function( _type ) self.settings.combatSessionDisplayBGType = _type self:SetCombatSessionDisplayBGType( _type ) self:UpdateCombatSessionDisplays() end
	)
	
	-- scale
	LAM:AddSlider(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_Scale_Combat_Session_Display_Slider",
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_COMBAT_SESSION_DISPLAY_SCALE_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_COMBAT_SESSION_DISPLAY_SCALE_TOOLTIP ] ),
		1, 6, 1,
		function() return self.settings.combatSessionDisplayScale end,
		function( _set ) self.settings.combatSessionDisplayScale = _set self:UpdateCombatSessionDisplays() end,
		nil, nil
	)
	
	-- bg transparency
	LAM:AddSlider(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_BG_Transparency_Combat_Session_Display_Slider",
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_COMBAT_SESSION_DISPLAY_BG_TRANSPARENCY_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_COMBAT_SESSION_DISPLAY_BG_TRANSPARENCY_TOOLTIP ] ),
		0, 100, 1,
		function() return self.settings.combatSessionDisplayBGTransparency end,
		function( _set ) self.settings.combatSessionDisplayBGTransparency = _set self:SetCombatSessionDisplayBGTransparency( _set ) end,
		nil, nil
	)
	
	-- text transparency
	LAM:AddSlider(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_Text_Transparency_Combat_Session_Display_Slider",
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_COMBAT_SESSION_DISPLAY_TEXT_TRANSPARENCY_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_COMBAT_SESSION_DISPLAY_TEXT_TRANSPARENCY_TOOLTIP ] ),
		0, 100, 1,
		function() return self.settings.combatSessionDisplayTextTransparency end,
		function( _set ) self.settings.combatSessionDisplayTextTransparency = _set self:SetCombatSessionDisplayTextTransparency( _set ) end,
		nil, nil
	)

	-- Header for the ability damage percentage
	LAM:AddDescription( TCS.settingsMenu, "TCS_SettingsMenu_AbilityDamagePercentages_spacing", "" )
	LAM:AddHeader( TCS.settingsMenu, "TCS_SettingsMenu_AbilityDamagePercentages", GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_LABEL ] ) )

	-- show bar indicators
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_AbilityDamagePercentages_Enable_Bar_Indicators_Checkbox", 
		GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_BAR_INDICATORS_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_BAR_INDICATORS_TOOLTIP ] ),
		function() return self.settings.combatSessionAbilityDamageEnableBarIndicators end,
		function( _set ) self.settings.combatSessionAbilityDamageEnableBarIndicators = _set self:UpdateAbilityDamagePercentagesEnabled() end,
		nil, nil
	)
	
	-- bar width
	LAM:AddSlider(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Width_Slider",
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_WIDTH_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_WIDTH_TOOLTIP ] ),
		0, 100, 1,
		function() return self.settings.combatSessionAbilityDamageBarWidth end,
		function( _set ) self.settings.combatSessionAbilityDamageBarWidth = _set self:UpdateAbilityDamagePercentagesWidth( true ) end,
		nil, nil
	)
	
	-- bar alighment
	LAM:AddDropdown(
		TCS.settingsMenu,
		"TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Alignment_Dropdown",
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_ALIGNMENT_LABEL ] ),
		GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_ALIGNMENT_TOOLTIP ] ),
		{
			GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_ALIGNMENT_LEFT ] ),
			GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_ALIGNMENT_RIGHT ] )
		},
		function() return self.settings.combatSessionAbilityDamageBarAlignment end,
		function( _type ) self.settings.combatSessionAbilityDamageBarAlignment = _type self:UpdateAbilityDamagePercentagesAlignment() end
	)
	
	-- bar color
	LAM:AddColorPicker(
		TCS.settingsMenu,
		"TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Color_Colorpicker",
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_COLOR_LABEL ] ),
		GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_INDICATORS_COLOR_TOOLTIP ] ),
		function() return self.settings.combatSessionAbilityDamageBarR, self.settings.combatSessionAbilityDamageBarG, self.settings.combatSessionAbilityDamageBarB end,
		function( r, g, b ) self.settings.combatSessionAbilityDamageBarR = r self.settings.combatSessionAbilityDamageBarG = g self.settings.combatSessionAbilityDamageBarB = b TCC.UpdateColorSelectionButtonColors() self:UpdateAbilityDamagePercentagesColor() end
	)
	
	-- show percentage indicator
	LAM:AddCheckbox(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_AbilityDamagePercentages_Enable_Percentage_Indicators_Checkbox", 
		GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_PERCENTAGE_INDICATORS_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_ENABLE_PERCENTAGE_INDICATORS_TOOLTIP ] ),
		function() return self.settings.combatSessionAbilityDamageEnablePercentage end,
		function( _set )
			self.settings.combatSessionAbilityDamageEnablePercentage = _set self:UpdateAbilityDamagePercentagesTextEnabled()
		end,
		nil, nil
	)
	
	-- percentage size
	LAM:AddSlider(
		TCS.settingsMenu, 
		"TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Size_Slider",
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_SIZE_LABEL ] ), 
		GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_SIZE_TOOLTIP ] ),
		1, 4, 1,
		function() return self.settings.combatSessionAbilityDamagePercentageSize end,
		function( _set ) self.settings.combatSessionAbilityDamagePercentageSize = _set self:UpdateAbilityDamagePercentagesTextSize() end,
		nil, nil
	)
	
	-- percentage alignment
	LAM:AddDropdown(
		TCS.settingsMenu,
		"TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Alignment_Dropdown",
		"     " .. GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_ALIGNMENT_LABEL ] ),
		GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_PERCENTAGE_INDICATORS_ALIGNMENT_TOOLTIP ] ),
		{
			GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_CENTER ] ),
			GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOP ] ),
			GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOM ] ),
			GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOPRIGHT ] ),
			GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOPLEFT ] ),
			GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOMRIGHT ] ),
			GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOMLEFT ] ),
			GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_RIGHT ] ),
			GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_LEFT ] )
		},
		function() return self.settings.combatSessionAbilityDamagePercentageAlignment end,
		function( _type ) self.settings.combatSessionAbilityDamagePercentageAlignment = _type self:UpdateAbilityDamagePercentagesTextAlignment() end
	)
	
	-- reset addon
	LAM:AddDescription( TCS.settingsMenu, "TCS_SettingsMenu_Global_spacing", "" )
	LAM:AddHeader( TCS.settingsMenu, "TCS_SettingsMenu_Global", GetString( _G[ self.localizedStrings.SETTINGS_GLOBAL_LABEL ] ) )
	
	LAM:AddButton(
		TCS.settingsMenu,
		"TCS_SettingsMenu_ResetAll",
		GetString( _G[ self.localizedStrings.SETTINGS_RESET_ALL_LABEL ] ),
		GetString( _G[ self.localizedStrings.SETTINGS_RESET_ALL_TOOLTIP ] ),
		function() self:ResetAll() ReloadUI() end,
		true, GetString( _G[ self.localizedStrings.SETTINGS_RESET ] ) )
		
	LAM:AddDescription( TCS.settingsMenu, "TCS_SettingsMenu_Global_spacing2", "" )
	LAM:AddDescription( TCS.settingsMenu, "TCS_SettingsMenu_Global_spacing3", "" )
	LAM:AddDescription( TCS.settingsMenu, "TCS_SettingsMenu_Global_spacing4", "" )
end

function TCS:ResetAll()
	self.settings.abilityStatistics = {}
	
	for i, v in pairs( self.settings.chatTabOptions ) do
		self.settings.chatTabOptions[i] = {}
	end
	
	self.settings.abilityStatisticOptions.enableTooltip 		= true
	self.settings.abilityStatisticOptions.showNormalAverage 	= true
	self.settings.abilityStatisticOptions.showNormalMaximum 	= true
	self.settings.abilityStatisticOptions.showNormalMinimum 	= true
	self.settings.abilityStatisticOptions.showCriticalAverage 	= true
	self.settings.abilityStatisticOptions.showCriticalMaximum 	= true
	self.settings.abilityStatisticOptions.showCriticalMinimum 	= true
	self.settings.abilityStatisticOptions.showTotalAverage		= true
	self.settings.abilityStatisticOptions.showCriticalPercent 	= true
	
	self.settings.alliancePointsMinimum 				= 5
	self.settings.enableCombatSessionDisplay			= true
	self.settings.showDPS								= true
	self.settings.totalDamage							= true
	self.settings.showHPS								= true
	self.settings.totalHealing							= true
	self.settings.combatSessionDisplayBGType 			= GetString( _G[ self.localizedStrings.SETTINGS_BACKGROUND_TYPE_A ] )
	self.settings.combatSessionDisplayScale				= 1
	self.settings.combatSessionDisplayBGTransparency	= 100
	self.settings.combatSessionDisplayTextTransparency 	= 100
	
	self.settings.combatSessionDPSDisplayPoint			= BOTTOM
	self.settings.combatSessionDPSDisplayRelativeTo		= GuiRoot
	self.settings.combatSessionDPSDisplayRelativePoint	= BOTTOM
	self.settings.combatSessionDPSDisplayOffsetX		= -70
	self.settings.combatSessionDPSDisplayOffsetY		= -73
	
	self.settings.combatSessionTotalDamageDisplayPoint			= BOTTOM
	self.settings.combatSessionTotalDamageDisplayRelativeTo		= GuiRoot
	self.settings.combatSessionTotalDamageDisplayRelativePoint	= BOTTOM
	self.settings.combatSessionTotalDamageDisplayOffsetX		= -210
	self.settings.combatSessionTotalDamageDisplayOffsetY		= -73

	self.settings.combatSessionHPSDisplayPoint			= BOTTOM
	self.settings.combatSessionHPSDisplayRelativeTo		= GuiRoot
	self.settings.combatSessionHPSDisplayRelativePoint	= BOTTOM
	self.settings.combatSessionHPSDisplayOffsetX		= 70
	self.settings.combatSessionHPSDisplayOffsetY		= -73
	
	self.settings.combatSessionTotalHealingDisplayPoint			= BOTTOM
	self.settings.combatSessionTotalHealingDisplayRelativeTo	= GuiRoot
	self.settings.combatSessionTotalHealingDisplayRelativePoint	= BOTTOM
	self.settings.combatSessionTotalHealingDisplayOffsetX		= 210
	self.settings.combatSessionTotalHealingDisplayOffsetY		= -73
	
	self.combatSessionExperiencedGained 	= 0
	self.combatSessionFinesseBonusExperiencePercentage 	= 0
	
	self.combatSessionDamageDealt = 0
	self.combatSessionHealingDone = 0
	
	self:ChatCombatOutputInitializeLastExperiences()
	
	self:SetCombatSessionDPSUpdateHidden()
	self:SetCombatSessionTotalDamageUpdateHidden()
	self:SetCombatSessionHPSUpdateHidden()
	self:SetCombatSessionTotalHealingUpdateHidden()
	
	self.settings.combatSessionAbilityDamageBarAlignment 			= GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_ALIGNMENT_LEFT ] )
	self.settings.combatSessionAbilityDamagePercentageAlignment 	= GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOMLEFT ] )
	self.settings.combatSessionAbilityDamageEnableBarIndicators 	= true
	self.settings.combatSessionAbilityDamageBarWidth 				= 15
	self.settings.combatSessionAbilityDamageBarR 					= 0.8039
	self.settings.combatSessionAbilityDamageBarG 					= 0.0862
	self.settings.combatSessionAbilityDamageBarB 					= 0.0862
	self.settings.combatSessionAbilityDamageEnablePercentage 		= true
	self.settings.combatSessionAbilityDamagePercentageSize 			= 1
	
	self:UpdateAbilityDamagePercentagesEnabled()
	self:UpdateAbilityDamagePercentagesWidth()
	self:UpdateAbilityDamagePercentagesColor()
	self:UpdateAbilityDamagePercentagesAlignment()
	self:UpdateAbilityDamagePercentagesTextEnabled()
	self:UpdateAbilityDamagePercentagesTextSize()
	self:UpdateAbilityDamagePercentagesTextAlignment()
	self:ResetAbilityDamagePercentage()
end

function TCS:OnUpdate()
	self:SkillTooltipOnUpdate()
end

----------------------------------
-- Chat Tab Options
----------------------------------
function TCS:ChatTabOptionsIntialize()
	-- Register handler
	self:RegisterHandler(
		ZO_ChatOptionsDialog, "OnShow",
		self.handlerBackups.zo_chatOptionsDialog,
		function()
			zo_callLater(
				function()
					for i = 1, self.chatTabFilterCount, 1 do
							local controlName 	= "Filter" .. i
							local settingName 	= TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ].CheckButton.settingName
							local tabIndex 		= CHAT_OPTIONS:GetCurrentTabIndex()
							if( self.settings.chatTabOptions[ tabIndex ] == nil ) then
								self.settings.chatTabOptions[ tabIndex ] = {}
							end
							
							ZO_CheckButton_SetCheckState(
								TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ].CheckButton,
								self.settings.chatTabOptions[ tabIndex ][ settingName ]
							)
					end
				end,
				10
			)
		end
	)
	
	-- Resize the chat tab options window
	ZO_ChatOptionsDialog:SetDimensionConstraints( 520, 915, 520, 915 )

	-- Create the new filter section
	TCS_ChatOptionsDialogTsCombatStatsLabel = WINDOW_MANAGER:CreateControl( "TCS_ChatOptionsDialogTsCombatStatsLabel", ZO_ChatOptionsDialog, CT_LABEL )
	TCS_ChatOptionsDialogTsCombatStatsLabel:SetText( "COMBAT STATISTICS" )
	TCS_ChatOptionsDialogTsCombatStatsLabel:SetFont( "ZoFontWinH3" )
	TCS_ChatOptionsDialogTsCombatStatsLabel:SetAnchor( TOPLEFT, ZO_ChatOptionsDialogGuildSection, BOTTOMLEFT, -10, 5 )

	-- Add the filters						
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_DAMAGE_DEALT ] ), 			"damageDealt" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_DAMAGE_RECEIVED ] ), 		"damageReceived" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_HEALING_DONE ] ), 			"healingDone" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_HEALING_RECEIVED ] ), 		"healingReceived" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_COMBAT_EXPERIENCE ] ), 		"combatExperience" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_FINESSE_EXPERIENCE ] ),		"finesseExperience" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_SKILL_LINE_EXPERIENCE ] ),	"skillLineExperience" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_ABILITY_EXPERIENCE ] ), 	"abilityExperience" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_BUFF_STATUS ] ), 			"buffStatus" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_DEBUFF_STATUS ] ), 			"debuffStatus" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_VETERAN_POINTS ] ), 		"veteranPoints" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_ALLIANCE_POINTS ] ), 		"alliancePoints" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_FINESSE_PROGRESSION ] ),	"finesseProgression" )
	self:AddChatTabFilter( TCS_ChatOptionsDialogTsCombatStatsLabel, GetString( _G[ self.localizedStrings.FILTER_COMBAT_START_END ] ),		"combatStartEnd" )
end

function TCS:AddChatTabFilter( _filterSection, _checkboxLabelText, _settingName )
	self.chatTabFilterCount = self.chatTabFilterCount + 1

	local controlName 	= "Filter" .. self.chatTabFilterCount
	local offsetX 		= self.chatTabFilterColumnCount * 240
	local offsetY 		= self.chatTabFilterRowCount * 25
	
	TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ] = WINDOW_MANAGER:CreateControl( "TCS_ChatOptionsDialogTsCombatStats" .. controlName, _filterSection, CT_CONTROL )
	TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ]:SetAnchor( TOPLEFT, _filterSection, BOTTOMLEFT, 10 + offsetX, 12 + offsetY )
	
	TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ].CheckButton = CreateControlFromVirtual( "TCS_ChatOptionsDialogTsCombatStats" .. controlName .. "CheckButton", TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ], "ZO_CheckButton" )
	TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ].CheckButton:SetAnchor( TOPLEFT, TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ], BOTTOMLEFT, 0, 0 )
	TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ].CheckButton.settingName = _settingName
	
	ZO_CheckButton_SetToggleFunction(
		TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ].CheckButton,
		function( _button, _checked )
			local tabIndex = CHAT_OPTIONS:GetCurrentTabIndex()
			
			if( self.settings.chatTabOptions[ tabIndex ] == nil ) then
				self.settings.chatTabOptions[ tabIndex ] = {}
			end

			if( _checked ) then
				self.settings.chatTabOptions[ tabIndex ][ _settingName ] = _checked
			else
				self.settings.chatTabOptions[ tabIndex ][ _settingName ] = nil
			end
		end
	)
	
	TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ].CheckLabel = CreateControlFromVirtual( "TCS_ChatOptionsDialogTsCombatStats" .. controlName .. "CheckLabel", TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ], "ZO_ChatOptionsDefaultLabel" )
	TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ].CheckLabel:SetAnchor( TOPLEFT, TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ].CheckButton, TOPRIGHT, 5, -2 )
	TCS_ChatOptionsDialogTsCombatStatsLabel[ controlName ].CheckLabel:SetText( _checkboxLabelText )
	
	self.chatTabFilterColumnCount = self.chatTabFilterColumnCount + 1
	if( self.chatTabFilterColumnCount == 2 ) then
		self.chatTabFilterColumnCount = 0
		self.chatTabFilterRowCount = self.chatTabFilterRowCount + 1
	end
end

----------------------------------
-- Chat Combat Output
----------------------------------
function TCS:ChatCombatOutputInitialize()
	-- Register Events
	self.control:RegisterForEvent( EVENT_PLAYER_COMBAT_STATE, 				function( ... ) self:OnEventPlayerCombatState( ... ) 						end )
	self.control:RegisterForEvent( EVENT_COMBAT_EVENT, 						function( ... ) self:OnEventCombatEvent( ... ) 								end )
	self.control:RegisterForEvent( EVENT_SKILL_XP_UPDATE, 					function( ... ) self:OnEventSkillXPUpdate( ... )							end )
	self.control:RegisterForEvent( EVENT_FINESSE_RANK_CHANGED, 				function( ... ) self:OnEventFinesseRankChanged( ... ) 						end )
	self.control:RegisterForEvent( EVENT_EFFECT_CHANGED, 					function( ... ) self:OnEventEffectChanged( ... ) 							end )
	self.control:RegisterForEvent( EVENT_VETERAN_POINTS_UPDATE, 			function( ... ) self:OnEventVeteranPointsUpdate( ... ) 						end )
	self.control:RegisterForEvent( EVENT_ALLIANCE_POINT_UPDATE, 			function( ... ) self:OnEventAlliancePointUpdate( ... ) 						end )
	self.control:RegisterForEvent( EVENT_SKILLS_FULL_UPDATE, 				function( ... ) zo_callLater( self.InitializeAbilityNameProxies, 1000 ) zo_callLater( self.InitializeabilityInfoCache, 1100 ) zo_callLater( self.ChatCombatOutputInitializeLastExperiences, 1100 ) end )
	
	-- Initialize
	self:ChatCombatOutputInitializeLastExperiences()
	self:InitializeabilityInfoCache()
	self:InitializeAbilityNameProxies()
end

function TCS:ChatCombatOutputInitializeLastExperiences()
	-- Player
	TCS.lastExperiences[ "player" ] = GetUnitXP( "player" )
	TCS.lastExperiences[ "playerVeteran" ] = GetUnitVeteranPoints( "player" ) 
	
	-- Skill Lines
	local skillTypeCount 	= GetNumSkillTypes()
	local skillCount 		= GetNumSkillLines( skillTypeCount )
	
	for i = 1, skillTypeCount, 1 do
		for j = 1, skillCount, 1 do
			local skillLastRankXp, skillNextRankXP, skillCurrentXP = GetSkillLineXPInfo( i, j )
			local skillName, skillRank = GetSkillLineInfo( i, j )
			local skillNameIndex = string.lower( string.gsub( skillName , "%^.*", "") )
			
			if( skillCurrentXP == nil ) then skillCurrentXP = 0 end
			
			TCS.lastExperiences[ skillNameIndex ] = skillCurrentXP
			
			-- Abilities
			local abilityCount = GetNumSkillAbilities( i, j )
			
			for k = 1, abilityCount, 1 do
				local abilityName, abilityTexture, abilityEarnedRank, abilityPassive, abilityUltimate, abilityPurchased, abilityProgressionIndex = GetSkillAbilityInfo( i, j, k )
				local abilityLastRankXp, abilityNextRankXP, abilityCurrentXP, abilityAtMorph = GetAbilityProgressionXPInfo( abilityProgressionIndex )
				abilityNameIndex = string.lower( string.gsub( abilityName , "%^.*", "") )

				if( not abilityPassive and abilityPurchased ) then
					local proxy = TCS.abilityNameProxies[ abilityNameIndex ]
					if( proxy ~= nil ) then abilityNameIndex = proxy end
					
					if( abilityCurrentXP == nil ) then abilityCurrentXP = 0 end

					TCS.lastExperiences[ abilityNameIndex ] = abilityCurrentXP
				end
			end
		end
	end
end

function TCS:InitializeabilityInfoCache()
	local skillTypeCount 	= GetNumSkillTypes()
	local skillCount 		= GetNumSkillLines( skillTypeCount )
	
	for i = 1, skillTypeCount, 1 do
		if( TCS.abilityInfoCache[ i ] == nil ) then TCS.abilityInfoCache[ i ] = {} end
		
		for j = 1, skillCount, 1 do
			if( TCS.abilityInfoCache[ i ][ j ] == nil ) then TCS.abilityInfoCache[ i ][ j ] = { name = "", abilityCount = 0, abilities = {} } end
			
			local skillName, skillRank = GetSkillLineInfo( i, j )
			TCS.abilityInfoCache[ i ][ j ].name = string.lower( string.gsub( skillName , "%^.*", "") )
			
			local abilityCount = GetNumSkillAbilities( i, j )
			TCS.abilityInfoCache[ i ][ j ].abilityCount = abilityCount
			
			for k = 1, abilityCount, 1 do
				if( TCS.abilityInfoCache[ i ][ j ].abilities[ k ] == nil ) then TCS.abilityInfoCache[ i ][ j ].abilities[ k ] = { name = "", progressionIndex = 0 } end
				
				local abilityName, abilityTexture, abilityEarnedRank, abilityPassive, abilityUltimate, abilityPurchased, abilityProgressionIndex = GetSkillAbilityInfo( i, j, k )
				local progressionName, progressionMorph, progressionRank = GetAbilityProgressionInfo( abilityProgressionIndex )
				abilityName = string.lower( string.gsub( abilityName, "%^.*", "" ) )
				
				if( not abilityPassive ) then
					local proxy = TCS.abilityNameProxies[ abilityName ]
					if( proxy ~= nil ) then abilityName = proxy end
					
					TCS.abilityInfoCache[ i ][ j ].abilities[ k ].name = abilityName
					TCS.abilityInfoCache[ i ][ j ].abilities[ k ].progressionIndex = abilityProgressionIndex
					TCS.abilityInfoCache[ i ][ j ].abilities[ k ].isPassive = abilityPassive
					TCS.abilityInfoCache[ i ][ j ].abilities[ k ].isPurchased = abilityPurchased
				end
			end
		end
	end
end

_tcsDebugAbilityProxies = nil
function TCS:InitializeAbilityNameProxies()
	local skillTypeCount 	= GetNumSkillTypes()
	local skillCount 		= GetNumSkillLines( skillTypeCount )

	for i = 1, skillTypeCount, 1 do
		for j = 1, skillCount, 1 do
			local abilityCount = GetNumSkillAbilities( i, j )

			for k = 1, abilityCount, 1 do
				local abilityName, abilityTexture, abilityEarnedRank, abilityPassive, abilityUltimate, abilityPurchased, abilityProgressionIndex = GetSkillAbilityInfo( i, j, k )

				if( abilityProgressionIndex ~= nil ) then
					local progressionName, progressionMorph, progressionRank = GetAbilityProgressionInfo( abilityProgressionIndex )

					abilityName = string.lower( string.gsub( abilityName, "%^.*", "" ) )
					progressionName = string.lower( string.gsub( progressionName, "%^.*", "" ) )

					TCS.abilityNameProxies[ abilityName ] = abilityName
					TCS.abilityNameProxies[ progressionName ] = abilityName
				end
			end
		end
	end
	
	-- destruction staff, element specific names
	if( TCS_LOCALE == "EN" ) then
		TCS.abilityNameProxies[ "frost touch" ] = "destructive touch"
		TCS.abilityNameProxies[ "fire touch" ] = "destructive touch"
		TCS.abilityNameProxies[ "shock touch" ] = "destructive touch"
		
		TCS.abilityNameProxies[ "frost clench" ] = "destructive clench"
		TCS.abilityNameProxies[ "fire clench" ] = "destructive clench"
		TCS.abilityNameProxies[ "shock clench" ] = "destructive clench"
		
		TCS.abilityNameProxies[ "frost reach" ] = "destructive reach"
		TCS.abilityNameProxies[ "fire reach" ] = "destructive reach"
		TCS.abilityNameProxies[ "shock reach" ] = "destructive reach"
		
		TCS.abilityNameProxies[ "wall of frost" ] = "wall of elements"
		TCS.abilityNameProxies[ "wall of fire" ] = "wall of elements"
		TCS.abilityNameProxies[ "wall of storms" ] = "wall of elements"
		
		TCS.abilityNameProxies[ "unstable wall of frost" ] = "unstable wall of elements"
		TCS.abilityNameProxies[ "unstable wall of fire" ] = "usnstable wall of elements"
		TCS.abilityNameProxies[ "unstable wall of storms" ] = "unstable wall of elements"
		
		TCS.abilityNameProxies[ "blockade of frost" ] = "elemental blockade"
		TCS.abilityNameProxies[ "blockade of fire" ] = "elemental blockade"
		TCS.abilityNameProxies[ "blockade of storms" ] = "elemental blockade"
		
		TCS.abilityNameProxies[ "fire impulse" ] = "impulse"
		TCS.abilityNameProxies[ "frost impulse" ] = "impulse"
		TCS.abilityNameProxies[ "shock impulse" ] = "impulse"

		TCS.abilityNameProxies[ "ring of fire" ] = "elemental ring"
		TCS.abilityNameProxies[ "ring of frost" ] = "elemental ring"
		TCS.abilityNameProxies[ "ring of shock" ] = "elemental ring"

		TCS.abilityNameProxies[ "fire pulsar" ] = "pulsar"
		TCS.abilityNameProxies[ "frost pulsar" ] = "pulsar"
		TCS.abilityNameProxies[ "shock pulsar" ] = "pulsar"
		
		TCS.abilityNameProxies[ "shock" ] = "energy overload"
		TCS.abilityNameProxies[ "electrocute" ] = "energy overload"
	elseif( TCS_LOCALE == "FR" ) then
		TCS.abilityNameProxies[ "toucher de feu" ] = "toucher destructeur"
		TCS.abilityNameProxies[ "toucher de givre" ] = "toucher destructeur"
		TCS.abilityNameProxies[ "toucher de foudre" ] = "toucher destructeur"
		
		TCS.abilityNameProxies[ "prise de feu" ] = "prise destructrice"
		TCS.abilityNameProxies[ "prise de givre" ] = "prise destructrice"
		TCS.abilityNameProxies[ "prise de foudre" ] = "prise destructrice"
		
		TCS.abilityNameProxies[ "allonge de foudre" ] = "allonge destructrice"
		TCS.abilityNameProxies[ "allonge de givre" ] = "allonge destructrice"
		TCS.abilityNameProxies[ "allonge de feu" ] = "allonge destructrice"
		
		TCS.abilityNameProxies[ "mur de feu" ] = "mur élémentaire"
		TCS.abilityNameProxies[ "mur de givre" ] = "mur élémentaire"
		TCS.abilityNameProxies[ "mur de tempêtes" ] = "mur élémentaire"
		
		TCS.abilityNameProxies[ "Mur de feu instable" ] = "mur élémentaire instable"
		TCS.abilityNameProxies[ "Mur de givre instable" ] = "mur élémentaire instable"
		TCS.abilityNameProxies[ "Mur de tempêtes instable" ] = "mur élémentaire instable"
		
		TCS.abilityNameProxies[ "barrage de feu" ] = "rempart élémentaire"
		TCS.abilityNameProxies[ "barrage de givre" ] = "rempart élémentaire"
		TCS.abilityNameProxies[ "barrage de tempêtes" ] = "rempart élémentaire"
		
		--TCS.abilityNameProxies[ "fire impulse" ] = "impulsion"
		--TCS.abilityNameProxies[ "frost impulse" ] = "impulsion"
		--TCS.abilityNameProxies[ "shock impulse" ] = "impulsion"

		--TCS.abilityNameProxies[ "ring of fire" ] = "cercle élémentaire"
		--TCS.abilityNameProxies[ "ring of frost" ] = "cercle élémentaire"
		--TCS.abilityNameProxies[ "ring of shock" ] = "cercle élémentaire"

		--TCS.abilityNameProxies[ "fire pulsar" ] = "pulsar"
		--TCS.abilityNameProxies[ "frost pulsar" ] = "pulsar"
		--TCS.abilityNameProxies[ "shock pulsar" ] = "pulsar"
		
		TCS.abilityNameProxies[ "décharge" ] = "surcharge d'énergie"
		TCS.abilityNameProxies[ "overload heavy attack" ] = "surcharge d'énergie"
	elseif( TCS_LOCALE == "DE" ) then
		TCS.abilityNameProxies[ "feuerberührung" ] = "zerstörerische berührung"
		TCS.abilityNameProxies[ "frostberührung" ] = "zerstörerische berührung"
		TCS.abilityNameProxies[ "schockberührung" ] = "zerstörerische berührung"
		
		TCS.abilityNameProxies[ "feuerhieb" ] = "zerstörerischer hieb"
		TCS.abilityNameProxies[ "frosthieb" ] = "zerstörerischer hieb"
		TCS.abilityNameProxies[ "schockhieb" ] = "zerstörerischer hieb"

		TCS.abilityNameProxies[ "schockfaust" ] = "zerstörerische faust"
		TCS.abilityNameProxies[ "frostfaust" ] = "zerstörerische faust"
		TCS.abilityNameProxies[ "feuerfaust" ] = "zerstörerische faust"
		
		TCS.abilityNameProxies[ "feuerwand" ] = "elementare wand"
		TCS.abilityNameProxies[ "frostwand" ] = "elementare wand"
		TCS.abilityNameProxies[ "sturmwand" ] = "elementare wand"
		
		TCS.abilityNameProxies[ "instabile feuerwand" ] = "instabile elementare wand"
		TCS.abilityNameProxies[ "instabile frostwand" ] = "instabile elementare wand"
		TCS.abilityNameProxies[ "instabile sturmwand" ] = "instabile elementare wand"
		
		TCS.abilityNameProxies[ "feuerblockade" ] = "elementare blockade"
		TCS.abilityNameProxies[ "frostblockade" ] = "elementare blockade"
		TCS.abilityNameProxies[ "sturmblockade" ] = "elementare blockade"
		
		--TCS.abilityNameProxies[ "fire impulse" ] = "impuls"
		--TCS.abilityNameProxies[ "frost impulse" ] = "impuls"
		--TCS.abilityNameProxies[ "shock impulse" ] = "impuls"

		--TCS.abilityNameProxies[ "ring of fire" ] = "elemental ring"
		--TCS.abilityNameProxies[ "ring of frost" ] = "elemental ring"
		--TCS.abilityNameProxies[ "ring of shock" ] = "elemental ring"

		--TCS.abilityNameProxies[ "fire pulsar" ] = "pulsar"
		--TCS.abilityNameProxies[ "frost pulsar" ] = "pulsar"
		--TCS.abilityNameProxies[ "shock pulsar" ] = "pulsar"
		
		TCS.abilityNameProxies[ "geladener schlag" ] = "energieüberladung"
		TCS.abilityNameProxies[ "overload heavy attack" ] = "energieüberladung"
	end
	
	-- typos
	if( TCS_LOCALE == "EN" ) then
		TCS.abilityNameProxies[ "critcal charge" ] = TCS.abilityNameProxies[ "critical charge" ]
	elseif( TCS_LOCALE == "FR" ) then
		TCS.abilityNameProxies[ "critcal charge" ] = TCS.abilityNameProxies[ "critical charge" ]
	elseif( TCS_LOCALE == "DE" ) then
		TCS.abilityNameProxies[ "critcal charge" ] = TCS.abilityNameProxies[ "critical charge" ]
	end
	
	_tcsDebugAbilityProxies = TCS.abilityNameProxies
end

function TCS:InitializeAbilityStatistic( _abilityNameIndex )
	self.settings.abilityStatistics[ _abilityNameIndex ] = {}

	self.settings.abilityStatistics[ _abilityNameIndex ].normalCount 		= 0
	self.settings.abilityStatistics[ _abilityNameIndex ].normalLowest 		= 0
	self.settings.abilityStatistics[ _abilityNameIndex ].normalHighest 		= 0
	self.settings.abilityStatistics[ _abilityNameIndex ].normalAverage 		= 0
	self.settings.abilityStatistics[ _abilityNameIndex ].criticalCount 		= 0
	self.settings.abilityStatistics[ _abilityNameIndex ].criticalLowest 	= 0
	self.settings.abilityStatistics[ _abilityNameIndex ].criticalHighest 	= 0
	self.settings.abilityStatistics[ _abilityNameIndex ].criticalAverage 	= 0
	self.settings.abilityStatistics[ _abilityNameIndex ].criticalPercent 	= 0.0
	self.settings.abilityStatistics[ _abilityNameIndex ].damageType 		= ""
end

function TCS:OnEventVeteranPointsUpdate( _eventCode, _unitTag, _currentPoints, _maxPoints, _reason )
	if( eventCode == EVENT_VETERAN_POINTS_UPDATE ) then
		local veteranPointsGained = _currentPoints - self.lastExperiences[ "playerVeteran" ]
		self.lastExperiences[ "playerVeteran" ] = _currentPoints
		
		self:DisplayMessage( "veteranPoints", self.localizedStrings.VETERAN_POINTS, veteranPointsGained )
	end
end

function TCS:OnEventAlliancePointUpdate( _eventCode, _alliancePoints, _playSound, _difference )
	if( _difference > self.settings.alliancePointsMinimum ) then
		self:DisplayMessage( "alliancePoints", self.localizedStrings.ALLIANCE_POINTS, _difference )
	end
end

function TCS:OnEventCombatEvent( _eventCode, _result, _isError, _abilityName, _abilityGraphic, _abilityActionSlotType, _sourceName, _sourceType, _targetName, _targetType, _hitValue, _powerType, _damageType, _log )
	if( _hitValue < 1 ) then return end
	
	local playerName		= GetUnitName( "player" )
	local sourceName 		= string.gsub( _sourceName , "%^.*", "")
	local targetName 		= string.gsub( _targetName , "%^.*", "")
	local abilityName 		= string.gsub( _abilityName, "%^.*", "" )
	local proxyName 		= self.abilityNameProxies[ string.lower( abilityName ) ]
	
	if( proxyName ~= nil ) then
		abilityName = proxyName:gsub("(%l)(%w*)", function(a,b) return string.upper(a)..b end)
	end
	
	if( _result == ACTION_RESULT_BLOCKED_DAMAGE ) then
		-- Damage Blocked
		if( targetName == playerName and sourceName ~= playerName ) then
			self:DisplayMessage( "damageReceived", self.localizedStrings.DAMAGE_BLOCKED, _hitValue )
		end
	elseif( _result == ACTION_RESULT_FALL_DAMAGE ) then
		-- Fall Damage-- Fall Damage
		if( targetName == playerName and sourceName ~= playerName ) then
			self:DisplayMessage( "damageReceived", self.localizedStrings.DAMAGE_FALL, _hitValue )
		end
	end
	
	-- Ability Statistics
	if( sourceName == playerName ) then
		local abilityNameIndex = nil
		
		if( _result == ACTION_RESULT_DAMAGE 			or _result == ACTION_RESULT_DOT_TICK 			or _result == ACTION_RESULT_HEAL 			or _result == ACTION_RESULT_HOT_TICK or
			_result == ACTION_RESULT_CRITICAL_DAMAGE 	or _result == ACTION_RESULT_DOT_TICK_CRITICAL 	or _result == ACTION_RESULT_CRITICAL_HEAL 	or _result == ACTION_RESULT_HOT_TICK_CRITICAL
		) then
			abilityNameIndex = string.lower( abilityName )
			
			if( abilityNameIndex ~= nil and self.settings.abilityStatistics[ abilityNameIndex ] == nil ) then
				self:InitializeAbilityStatistic( abilityNameIndex )
			end
		end
		
		if( self.settings.abilityStatistics[ abilityNameIndex ] ~= nil ) then
			if( self.settings.abilityStatistics[ abilityNameIndex ].normalCount > 1000 ) then
				self.settings.abilityStatistics[ abilityNameIndex ].normalCount 	= 10
				self.settings.abilityStatistics[ abilityNameIndex ].criticalCount 	= 10 * ( self.settings.abilityStatistics[ abilityNameIndex ].criticalPercent / 100 )
			end
			
			if( _result == ACTION_RESULT_DAMAGE or _result == ACTION_RESULT_DOT_TICK or _result == ACTION_RESULT_HEAL or _result == ACTION_RESULT_HOT_TICK ) then
				if( _hitValue < self.settings.abilityStatistics[ abilityNameIndex ].normalLowest ) then
					self.settings.abilityStatistics[ abilityNameIndex ].normalLowest = _hitValue
					
					if( self.settings.abilityStatistics[ abilityNameIndex ].normalHighest == 0 ) then
						self.settings.abilityStatistics[ abilityNameIndex ].normalHighest = _hitValue
					end
				elseif( _hitValue > self.settings.abilityStatistics[ abilityNameIndex ].normalHighest ) then
					self.settings.abilityStatistics[ abilityNameIndex ].normalHighest = _hitValue
					
					if( self.settings.abilityStatistics[ abilityNameIndex ].normalLowest == 0 ) then
						self.settings.abilityStatistics[ abilityNameIndex ].normalLowest = _hitValue
					end
				end
				
				if( self.settings.abilityStatistics[ abilityNameIndex ].normalAverage == 0 ) then
					self.settings.abilityStatistics[ abilityNameIndex ].normalAverage = _hitValue
				end

				self.settings.abilityStatistics[ abilityNameIndex ].normalCount 	= self.settings.abilityStatistics[ abilityNameIndex ].normalCount + 1
				self.settings.abilityStatistics[ abilityNameIndex ].normalAverage 	= ( _hitValue + self.settings.abilityStatistics[ abilityNameIndex ].normalAverage ) / 2
			elseif( _result == ACTION_RESULT_CRITICAL_DAMAGE or _result == ACTION_RESULT_DOT_TICK_CRITICAL or _result == ACTION_RESULT_CRITICAL_HEAL or _result == ACTION_RESULT_HOT_TICK_CRITICAL ) then			
				if( _hitValue < self.settings.abilityStatistics[ abilityNameIndex ].criticalLowest ) then
					self.settings.abilityStatistics[ abilityNameIndex ].criticalLowest = _hitValue
					
					if( self.settings.abilityStatistics[ abilityNameIndex ].criticalHighest == 0 ) then
						self.settings.abilityStatistics[ abilityNameIndex ].criticalHighest = _hitValue
					end
				elseif( _hitValue > self.settings.abilityStatistics[ abilityNameIndex ].criticalHighest ) then
					self.settings.abilityStatistics[ abilityNameIndex ].criticalHighest = _hitValue
					
					if( self.settings.abilityStatistics[ abilityNameIndex ].criticalLowest == 0 ) then
						self.settings.abilityStatistics[ abilityNameIndex ].criticalLowest = _hitValue
					end
				end
				
				if( self.settings.abilityStatistics[ abilityNameIndex ].criticalAverage == 0 ) then
					self.settings.abilityStatistics[ abilityNameIndex ].criticalAverage = _hitValue
				end

				self.settings.abilityStatistics[ abilityNameIndex ].criticalCount	= self.settings.abilityStatistics[ abilityNameIndex ].criticalCount + 1
				self.settings.abilityStatistics[ abilityNameIndex ].criticalAverage	= ( _hitValue + self.settings.abilityStatistics[ abilityNameIndex ].criticalAverage ) / 2
				self.settings.abilityStatistics[ abilityNameIndex ].criticalPercent = ( self.settings.abilityStatistics[ abilityNameIndex ].criticalCount / ( self.settings.abilityStatistics[ abilityNameIndex ].normalCount + self.settings.abilityStatistics[ abilityNameIndex ].criticalCount ) ) * 100
			end
			
			if( _result == ACTION_RESULT_DAMAGE or _result == ACTION_RESULT_DOT_TICK or _result == ACTION_RESULT_CRITICAL_DAMAGE or _result == ACTION_RESULT_DOT_TICK_CRITICAL ) then
				self.settings.abilityStatistics[ abilityNameIndex ].damageType =  zo_strformat( GetString( _G[ self.localizedStrings.TYPE_DAMAGE ] ), GetString( _G[ self.damageTypeStrings[ _damageType ] ] ) )

				self.combatSessionDamageDealt = self.combatSessionDamageDealt + _hitValue
				self:UpdateCombatSessionDisplays()
				self:UpdateAbilityDamagePercentage( string.lower( abilityName ), _hitValue )
			elseif( _result == ACTION_RESULT_HEAL or _result == ACTION_RESULT_HOT_TICK or _result == ACTION_RESULT_CRITICAL_HEAL or _result == ACTION_RESULT_HOT_TICK_CRITICAL) then
				self.settings.abilityStatistics[ abilityNameIndex ].damageType = GetString( _G[ self.localizedStrings.TYPE_HEALING ] )
				
				self.combatSessionHealingDone = self.combatSessionHealingDone + _hitValue
				self:UpdateCombatSessionDisplays()
			end
		end
	end
	
	-- Damage Dealt / Taken
	if( _result == ACTION_RESULT_DAMAGE or _result == ACTION_RESULT_DOT_TICK ) then
		if( targetName ~= playerName and sourceName == playerName ) then
			self:DisplayMessage( "damageDealt", self.localizedStrings.DAMAGE_DEALT, _hitValue, GetString( _G[ self.damageTypeStrings[ _damageType ] ] ), abilityName, targetName )
		elseif( targetName == playerName ) then
			if( sourceName ~= playerName ) then
				self:DisplayMessage( "damageReceived", self.localizedStrings.DAMAGE_TAKEN, _hitValue )
			elseif( sourceName == playerName ) then
				self:DisplayMessage( "damageReceived", self.localizedStrings.DAMAGE_TAKEN_SELF, _hitValue, GetString( _G[ self.damageTypeStrings[ _damageType ] ] ), abilityName )
			end
		end
	elseif( _result == ACTION_RESULT_CRITICAL_DAMAGE or _result == ACTION_RESULT_DOT_TICK_CRITICAL ) then
		if( targetName ~= playerName and sourceName == playerName ) then
			self:DisplayMessage( "damageDealt", self.localizedStrings.DAMAGE_DEALT_CRITICAL, _hitValue, GetString( _G[ self.damageTypeStrings[ _damageType ] ] ), abilityName, targetName )
		elseif( targetName == playerName ) then
			if( sourceName ~= playerName ) then
				self:DisplayMessage( "damageReceived", self.localizedStrings.DAMAGE_TAKEN_CRITICAL, _hitValue )
			elseif( sourceName == playerName ) then
				self:DisplayMessage( "damageReceived", self.localizedStrings.DAMAGE_TAKEN_CRITICAL_SELF, _hitValue, GetString( _G[ self.damageTypeStrings[ _damageType ] ] ), abilityName )
			end
		end
	end
	
	-- Healing Done/Recieved
	if( _result == ACTION_RESULT_HEAL or _result == ACTION_RESULT_HOT_TICK ) then
		if( sourceName == playerName and targetName ~= playerName ) then
			self:DisplayMessage( "healingDone", self.localizedStrings.HEALING_DONE, targetName, _hitValue, abilityName )
		elseif( targetName == playerName ) then
			if( sourceName ~= playerName ) then
				self:DisplayMessage( "healingReceived", self.localizedStrings.HEALING_RECEIVED, _hitValue )
			elseif( sourceName == playerName ) then
				self:DisplayMessage( "healingReceived", self.localizedStrings.HEALING_RECEIVED_SELF, _hitValue, abilityName )
			end
		end
	elseif(	_result == ACTION_RESULT_CRITICAL_HEAL or _result == ACTION_RESULT_HOT_TICK_CRITICAL ) then
		if( sourceName == playerName and targetName ~= playerName ) then
			self:DisplayMessage( "healingDone", self.localizedStrings.HEALING_DONE_CRITICAL, targetName, _hitValue, abilityName )
		elseif( targetName == playerName ) then
			if( sourceName ~= playerName ) then
				self:DisplayMessage( "healingReceived", self.localizedStrings.HEALING_RECEIVED_CRITICAL, _hitValue )
			elseif( sourceName == playerName ) then
				self:DisplayMessage( "healingReceived", self.localizedStrings.HEALING_RECEIVED_CRITICAL_SELF, _hitValue, abilityName )
			end
		end
	end

	if( _result == ACTION_RESULT_DIED_XP and sourceName == playerName and GetUnitLevel( "player" ) ~= 50 ) then
		-- Kill Experience
		self.combatSessionExperiencedGained = self.combatSessionExperiencedGained + _hitValue

		self:DisplayMessage( "combatExperience", self.localizedStrings.COMBAT_EXPERIENCE, _hitValue, _targetName )
	elseif( _result == ACTION_RESULT_DIED and sourceName == playerName and GetUnitLevel( "player" ) ~= 50 ) then
		-- Kill No Experience
		self:DisplayMessage( "combatExperience", self.localizedStrings.COMBAT_NO_EXPERIENCE, _targetName )
	end
end

function TCS:OnEventEffectChanged( _eventCode, _changeType, _effectSlot, _effectName, _unitTag, _beginTime, _endTime, _stackCount, _iconName, _buffType, _effectType, _abilityType, _statusEffectType )
	if( _unitTag ~= "player" or _effectName == nil or _effectName == "" ) then
		return
	end
	
	if( _effectType == BUFF_EFFECT_TYPE_BUFF ) then
		if( _changeType == 1 ) then
			self:DisplayMessage( "buffStatus", self.localizedStrings.BUFF_STATUS_GAIN, 	_effectName )
		elseif( _changeType == 2 ) then
			self:DisplayMessage( "buffStatus", self.localizedStrings.BUFF_STATUS_LOOSE, _effectName )
		end
	elseif( _effectType == BUFF_EFFECT_TYPE_DEBUFF ) then
		if( _changeType == 1 ) then
			self:DisplayMessage( "debuffStatus", self.localizedStrings.DEBUFF_STATUS_GAIN, 	_effectName )
		elseif( _changeType == 2 ) then
			self:DisplayMessage( "debuffStatus", self.localizedStrings.DEBUFF_STATUS_LOOSE, _effectName )
		end
	else
		if( _changeType == 1 ) then
			self:DisplayMessage( "buffStatus", self.localizedStrings.EFFECT_STATUS_GAIN,	_effectName )
		elseif( _changeType == 2 ) then
			self:DisplayMessage( "buffStatus", self.localizedStrings.EFFECT_STATUS_LOOSE,	_effectName )
		end
	end
end

function TCS:OnEventPlayerCombatState( _eventCode, _inCombat )
	self.isInCombat	= _inCombat

	if( _inCombat ) then 
		if( GetUnitLevel( "player" ) ~= 50 ) then
			self.combatSessionExperiencedGained 	= 0
			self.combatSessionFinesseBonusExperiencePercentage 	= 0
			self.lastExperiences[ "player" ] 		= GetUnitXP( 'Player' )
		else
			self.lastExperiences[ "playerVeteran" ] = GetUnitVeteranPoints( "player" )
		end
		
		self.combatSessionStartTime						= GetGameTimeMilliseconds()
		self.combatSessionDamageDealt 					= 0
		self.combatSessionHealingDone 					= 0
		self.combatSessionDPSNextSampleUpdate			= 0
		self.combatSessionAverageDPSSampleCounter 		= 0
		self.combatSessionAverageDPSSamples				= {}
		self.combatSessionHPSNextSampleUpdate			= 0
		self.combatSessionAverageHPSSampleCounter		= 0
		self.combatSessionAverageHPSSamples				= {}
		self.combatSessionSkillAbilityExperienceGained 	= {}
		self:ResetAbilityDamagePercentage()

		self:DisplayMessage( "combatStartEnd", self.localizedStrings.COMBAT_START )
	else
		zo_callLater(
			function()
				for i, v in pairs( self.combatSessionSkillAbilityExperienceGained ) do
					if( v.skillLineExperienceGained ~= 0 ) then self:DisplayMessage( "skillLineExperience", self.localizedStrings.SKILL_LINE_EXPERIENCE, v.skillLineExperienceGained, i ) end
					if( v.abilitiesExperienceGained ~= 0 ) then self:DisplayMessage( "abilityExperience", self.localizedStrings.ABILITY_EXPERIENCE, v.abilitiesExperienceGained, i ) end
				end
				
				if( GetUnitLevel( "player" ) ~= 50 ) then
					if( self.combatSessionFinesseBonusExperiencePercentage > 0 ) then
						local finesseExperience = math.floor( ( self.combatSessionExperiencedGained * self.combatSessionFinesseBonusExperiencePercentage ) + 0.5 )
						
						self:DisplayMessage( "finesseExperience", self.localizedStrings.FINESSE_EXPERIENCE, finesseExperience )
					end
				end
				
				self:DisplayMessage( "combatStartEnd", self.localizedStrings.COMBAT_END )
			end, 
			50 
		)
	end
end

function TCS:OnEventFinesseRankChanged( _eventCode, _unitTag, _rankNum, _name, _xpBonus, _loot)
	if( _unitTag ~= "player" ) then return end
	
	self.combatSessionFinesseBonusExperiencePercentage = _xpBonus / 100

	if( _loot ) then
		if( GetUnitLevel( "player" ) == 50 ) then
			self:DisplayMessage( "finesseProgression", self.localizedStrings.FINESSE_PROGRESSION_LOOT_NOXP, _name )
		else
			self:DisplayMessage( "finesseProgression", self.localizedStrings.FINESSE_PROGRESSION_LOOT, _name, _xpBonus )
		end
	else
		if( GetUnitLevel( "player" ) == 50 ) then
			self:DisplayMessage( "finesseProgression", self.localizedStrings.FINESSE_PROGRESSION_NOXP, _name )
		else
			self:DisplayMessage( "finesseProgression", self.localizedStrings.FINESSE_PROGRESSION, _name, _xpBonus )
		end
	end
end

function TCS:OnEventSkillXPUpdate( _eventCode, _skillType, _skillIndex, _lastRankXP, _nextRankXP, _currentXP )
	-- Skill Experience
	-- Calculate the skill experience gained
	local skillName = self.abilityInfoCache[ _skillType ][ _skillIndex ].name
	local skillNameIndex = string.lower( skillName )
	
	if( string.find( skillName, GetUnitRace("player") ) ~= nil ) then return end

	local skillExperienceGained = _currentXP - self.lastExperiences[ skillNameIndex ]
	self.lastExperiences[ skillNameIndex ] = _currentXP

	if( skillExperienceGained ~= 0 ) then
		if( self.combatSessionSkillAbilityExperienceGained[ skillName ] == nil ) then
			self.combatSessionSkillAbilityExperienceGained[ skillName ] =
			{
				skillLineExperienceGained = 0,
				abilitiesExperienceGained = 0
			}
		end
		
		self.combatSessionSkillAbilityExperienceGained[ skillName ].skillLineExperienceGained = self.combatSessionSkillAbilityExperienceGained[ skillName ].skillLineExperienceGained + skillExperienceGained
	end
	
	-- Ability Experience
	local abilityCount = self.abilityInfoCache[ _skillType ][ _skillIndex ].abilityCount
	
	for i = 1, abilityCount, 1 do
		local abilityIsPurchased = self.abilityInfoCache[ _skillType ][ _skillIndex ].abilities[ i ].isPurchased
		local abilityIsPassive = self.abilityInfoCache[ _skillType ][ _skillIndex ].abilities[ i ].isPassive
		
		if( abilityIsPurchased and not abilityIsPassive ) then
			local abilityName = self.abilityInfoCache[ _skillType ][ _skillIndex ].abilities[ i ].name
			local abilityNameIndex = string.lower( abilityName )
			local abilityLastRankXp, abilityNextRankXP, abilityCurrentXP, abilityAtMorph = GetAbilityProgressionXPInfo( self.abilityInfoCache[ _skillType ][ _skillIndex ].abilities[ i ].progressionIndex )
		
			-- Calculate the ability experience gained
			if ( self.lastExperiences[ abilityNameIndex ] == nil ) then self.lastExperiences[ abilityNameIndex ] = 0 end
			
			local abilityExperienceGained = abilityCurrentXP - self.lastExperiences[ abilityNameIndex ]
			self.lastExperiences[ abilityNameIndex ] = abilityCurrentXP

			if( abilityExperienceGained ~= 0 ) then
				if( self.combatSessionSkillAbilityExperienceGained[ skillName ] == nil ) then
					self.combatSessionSkillAbilityExperienceGained[ skillName ] =
					{
						skillLineExperienceGained = 0,
						abilitiesExperienceGained = 0
					}
				end

				self.combatSessionSkillAbilityExperienceGained[ skillName ].abilitiesExperienceGained = self.combatSessionSkillAbilityExperienceGained[ skillName ].abilitiesExperienceGained + abilityExperienceGained
				
				break
			end
		end
	end
end

function TCS:DisplayMessage( _filter, _message, ... )
	for i, j in pairs(self.settings.chatTabOptions) do
		if( self.settings.chatTabOptions[ i ][ _filter ] == true ) then
			local tab = _G[ "ZO_ChatWindowTemplate" .. i .. "Buffer" ]
			if( tab == nil ) then return end
			
			local message = _G[ _message ]
			if( message == nil or message == "" ) then return end
			
			tab:AddMessage( zo_strformat( GetString( message ), ... ) )
		end
	end
end

----------------------------------
-- Skill Tooltip
----------------------------------
function TCS:SkillTooltipInitialize()
	-- Function prehooks
	ZO_PreHook(
		"ZO_AbilityTooltip_OnAddGameData",
		function()
			self.toolTipInitializeCounter = self.toolTipInitializeCounter + 1
			
			if( self.toolTipInitializeCounter == 2 ) then
				self:SkillTooltipUpdateTooltip( AbilityTooltip )
			end
		end
	)
	
	ZO_PreHook(
		"ZO_SkillTooltip_OnAddGameData",
		function()
			self.toolTipInitializeCounter = self.toolTipInitializeCounter + 1
			
			if( self.toolTipInitializeCounter == 2 ) then
				self:SkillTooltipUpdateTooltip( SkillTooltip )
			end
		end
	)
	
	-- Register handlers
	self:RegisterHandler(
		self.control, "OnUpdate",
		self.handlerBackups.control,
		function() self:OnUpdate() end
	)
end

function TCS:SkillTooltipOnUpdate()
	-- execture when the mouseover has changed
	if( WINDOW_MANAGER:GetMouseOverControl() ~= self.lastMouseOver ) then
		self.lastMouseOver = WINDOW_MANAGER:GetMouseOverControl()
		self.toolTipInitializeCounter = 0
	end
end

function TCS:SkillTooltipUpdateTooltip( _tooltip )
	_tooltip:AddVerticalPadding( 3 )

	local control = WINDOW_MANAGER:GetMouseOverControl()
	
	-- Get the ability name
	if( control.slotNum ~= nil ) then abilityNameIndex = string.lower( string.gsub( GetSlotName( control.slotNum ), "%^.*", "") ) end
	if( control.ability ~= nil and control.ability.purchased ) then abilityNameIndex = string.lower( string.gsub( control.ability.plainName, "%^.*", "") ) end
	
	local proxy = self.abilityNameProxies[ string.lower( abilityNameIndex ) ]
	if( proxy ~= nil ) then abilityNameIndex = proxy end

	-- Dont do anything if there is nothing to display
	if(	abilityNameIndex == nil or abilityNameIndex == "" or self.settings.abilityStatistics[ abilityNameIndex ] == nil or not self.settings.abilityStatisticOptions.enableTooltip or (
		self.settings.abilityStatistics[ abilityNameIndex ].normalAverage	== 0 and self.settings.abilityStatistics[ abilityNameIndex ].normalHighest 		== 0 and
		self.settings.abilityStatistics[ abilityNameIndex ].normalLowest 	== 0 and self.settings.abilityStatistics[ abilityNameIndex ].criticalAverage 	== 0 and
		self.settings.abilityStatistics[ abilityNameIndex ].criticalHighest == 0 and self.settings.abilityStatistics[ abilityNameIndex ].criticalLowest		== 0 
		) 
	) then
		return
	end

	-- Display the statistics
	local paddingNeeded = false
	
	if( tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalAverage ) ~= 0 and self.settings.abilityStatisticOptions.showNormalAverage ) then
		self:SkillTooltipAddLine( _tooltip, zo_strformat( GetString( _G[ self.localizedStrings.GENERIC_AVERAGE ] ), self.settings.abilityStatistics[ abilityNameIndex ].damageType ), round( tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalAverage ), 0 ) )
		
		paddingNeeded = true
	end
	
	if( tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalAverage ) ~= 0 and self.settings.abilityStatisticOptions.showNormalAverage and
		tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalHighest ) ~= 0 and self.settings.abilityStatisticOptions.showNormalMaximum
	) then
		self:SkillTooltipAddLine( 	_tooltip, 	"     " .. zo_strformat( GetString( _G[ self.localizedStrings.GENERIC_MAXIMUM ] ), self.settings.abilityStatistics[ abilityNameIndex ].damageType ), tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalHighest ) )
	
		paddingNeeded = true
	end
	
	if( tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalAverage ) ~= 0 and self.settings.abilityStatisticOptions.showNormalAverage and
		tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalLowest ) ~= 0 and self.settings.abilityStatisticOptions.showNormalMinimum
	) then
		self:SkillTooltipAddLine( 	_tooltip, 	"     " .. zo_strformat( GetString( _G[ self.localizedStrings.GENERIC_MINIMUM ] ), self.settings.abilityStatistics[ abilityNameIndex ].damageType ), tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalLowest ) )
	
		paddingNeeded = true
	end

	if( not self.settings.abilityStatisticOptions.showNormalAverage and
		tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalHighest ) ~= 0 and self.settings.abilityStatisticOptions.showNormalMaximum
	) then
		self:SkillTooltipAddLine( 	_tooltip, 	zo_strformat( GetString( _G[ self.localizedStrings.GENERIC_MAXIMUM ] ), self.settings.abilityStatistics[ abilityNameIndex ].damageType ), tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalHighest ) )
	
		paddingNeeded = true
	end
	
	if( not self.settings.abilityStatisticOptions.showNormalAverage and
		tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalLowest ) ~= 0 and self.settings.abilityStatisticOptions.showNormalMinimum
	) then
		self:SkillTooltipAddLine( 	_tooltip, 	zo_strformat( GetString( _G[ self.localizedStrings.GENERIC_MINIMUM ] ), self.settings.abilityStatistics[ abilityNameIndex ].damageType ), tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalLowest ) )
	
		paddingNeeded = true
	end
	
	if( paddingNeeded ) then
		_tooltip:AddVerticalPadding( 8 )
	end
	
	paddingNeeded = false
	if( tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalAverage ) ~= 0 and self.settings.abilityStatisticOptions.showCriticalAverage ) then
		self:SkillTooltipAddLine( 	_tooltip, 	zo_strformat( GetString( _G[ self.localizedStrings.GENERIC_AVERAGE_CRITICAL ] ), self.settings.abilityStatistics[ abilityNameIndex ].damageType ), round( tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalAverage ), 0 ) )
		paddingNeeded = true
	end
	
	if( tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalAverage ) ~= 0 and self.settings.abilityStatisticOptions.showCriticalAverage and
		tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalHighest ) ~= 0 and self.settings.abilityStatisticOptions.showCriticalMaximum
	) then
		self:SkillTooltipAddLine( 	_tooltip, 	"     " .. zo_strformat( GetString( _G[ self.localizedStrings.GENERIC_MAXIMUM_CRITICAL ] ), self.settings.abilityStatistics[ abilityNameIndex ].damageType ), tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalHighest ) )
		paddingNeeded = true
	end
	
	if( tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalAverage ) ~= 0 and self.settings.abilityStatisticOptions.showCriticalAverage and
		tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalLowest ) ~= 0 and self.settings.abilityStatisticOptions.showCriticalMinimum
	) then
		self:SkillTooltipAddLine( 	_tooltip, 	"     " .. zo_strformat( GetString( _G[ self.localizedStrings.GENERIC_MINIMUM ] ), self.settings.abilityStatistics[ abilityNameIndex ].damageType ), tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalLowest ) )
		paddingNeeded = true
	end

	if( not self.settings.abilityStatisticOptions.showCriticalAverage and
		tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalHighest ) ~= 0 and self.settings.abilityStatisticOptions.showCriticalMaximum
	) then
		self:SkillTooltipAddLine( 	_tooltip, 	zo_strformat( GetString( _G[ self.localizedStrings.GENERIC_MAXIMUM_CRITICAL ] ), self.settings.abilityStatistics[ abilityNameIndex ].damageType ), tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalHighest ) )
		paddingNeeded = true
	end
	
	if( not self.settings.abilityStatisticOptions.showCriticalAverage and
		tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalLowest ) ~= 0 and self.settings.abilityStatisticOptions.showCriticalMinimum
	) then
		self:SkillTooltipAddLine( 	_tooltip, 	zo_strformat( GetString( _G[ self.localizedStrings.GENERIC_MINIMUM ] ), self.settings.abilityStatistics[ abilityNameIndex ].damageType ), tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalLowest ) )
		paddingNeeded = true
	end
	
	if( paddingNeeded ) then
		_tooltip:AddVerticalPadding( 8 )
	end
	
	local normalAverage 	= tonumber( self.settings.abilityStatistics[ abilityNameIndex ].normalAverage )
	local criticalAverage 	= tonumber( self.settings.abilityStatistics[ abilityNameIndex ].criticalAverage )
	local totalAverage 		= 0
	
	if( normalAverage == 0 ) then
		totalAverage = criticalAverage
	elseif( criticalAverage == 0 ) then
		totalAverage = normalAverage
	else
		totalAverage = ( normalAverage + criticalAverage ) / 2
	end
	
	if( self.settings.abilityStatisticOptions.showTotalAverage ) then
		self:SkillTooltipAddLine( 	_tooltip, 	zo_strformat( GetString( _G[ self.localizedStrings.GENERIC_TOTAL_AVERAGE ] ), self.settings.abilityStatistics[ abilityNameIndex ].damageType ), round( totalAverage, 0 ) )
	end
	
	if( self.settings.abilityStatisticOptions.showCriticalPercent ) then
		self:SkillTooltipAddLine( 	_tooltip, 	GetString( _G[ self.localizedStrings.GENERIC_CRITICAL_CHANCE ] ), round( self.settings.abilityStatistics[ abilityNameIndex ].criticalPercent, 2 ) .. "%" )
	end
	
	if(	self.settings.abilityStatisticOptions.showNormalAverage or 		self.settings.abilityStatisticOptions.showNormalMaximum or
		self.settings.abilityStatisticOptions.showNormalMinimum or 		self.settings.abilityStatisticOptions.showCriticalAverage or
		self.settings.abilityStatisticOptions.showCriticalMaximum or 	self.settings.abilityStatisticOptions.showCriticalMinimum or
		self.settings.abilityStatisticOptions.showTotalAverage or 		self.settings.abilityStatisticOptions.showCriticalPercent
	) then
		_tooltip:AddVerticalPadding( 10 )
	end
end

function TCS:SkillTooltipAddLine( _tooltip, _valueName, _value )
	local valueName = "|cC5C29E" .. tostring( _valueName ) .. "|r"
	local value 	= tostring( _value )
	
	_tooltip:AddLine( valueName, self.TOOLTIP_FONT, 1, 1, 1, nil, nil, TEXT_ALIGN_LEFT, true )
	
	_tooltip:AddVerticalPadding( -25 )
	_tooltip:AddLine( value, self.TOOLTIP_FONT, 1, 1, 1, nil, nil, TEXT_ALIGN_RIGHT, true )
	
	_tooltip:AddVerticalPadding( 1 )
end

----------------------------------
-- Combat Session
----------------------------------
function TCS:CombatSessionDisplayInitialize()
	-- DPS
	self.combatSessionDPSDisplay = WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_DPS_Display", ZO_ActionBar1, CT_TEXTURE )
	self.combatSessionDPSDisplay:SetDimensions( 121, 20 )
	self.combatSessionDPSDisplay:SetMouseEnabled( true )
	self.combatSessionDPSDisplay:SetMovable( true )
	self.combatSessionDPSDisplay:SetAnchor(
		self.settings.combatSessionDPSDisplayPoint,
		self.settings.combatSessionDPSDisplayRelativeTo,
		self.settings.combatSessionDPSDisplayRelativePoint,
		self.settings.combatSessionDPSDisplayOffsetX,
		self.settings.combatSessionDPSDisplayOffsetY
	)
	
	self.combatSessionDPSDisplay.dps = WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Display_DPS_Label", ZO_ActionBar1, CT_LABEL )
	self.combatSessionDPSDisplay.dps:SetAnchor( CENTER, TCS_Combat_Session_DPS_Display, CENTER, 0, -1 )
	self.combatSessionDPSDisplay.dps:SetText( GetString( _G[ self.localizedStrings.GENERIC_DPS ] ) .. ": 0" )
	
	self:SetCombatSessionDPSUpdateHidden()
	
	-- Total Damage
	self.combatSessionTotalDamageDisplay = WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Total_Damage_Display", ZO_ActionBar1, CT_TEXTURE )
	self.combatSessionTotalDamageDisplay:SetDimensions( 121, 20 )
	self.combatSessionTotalDamageDisplay:SetMouseEnabled( true )
	self.combatSessionTotalDamageDisplay:SetMovable( true )
	self.combatSessionTotalDamageDisplay:SetAnchor(
		self.settings.combatSessionTotalDamageDisplayPoint,
		self.settings.combatSessionTotalDamageDisplayRelativeTo,
		self.settings.combatSessionTotalDamageDisplayRelativePoint,
		self.settings.combatSessionTotalDamageDisplayOffsetX,
		self.settings.combatSessionTotalDamageDisplayOffsetY
	)
	
	self.combatSessionTotalDamageDisplay.totalDamage = WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Display_Total_Damage_Label", ZO_ActionBar1, CT_LABEL )
	self.combatSessionTotalDamageDisplay.totalDamage:SetAnchor( CENTER, TCS_Combat_Session_Total_Damage_Display, CENTER, 0, -1 )
	self.combatSessionTotalDamageDisplay.totalDamage:SetText( GetString( _G[ self.localizedStrings.SETTINGS_DAMAGE_TOTAL_LABEL ] ) .. ": 0" )
	
	self:SetCombatSessionTotalDamageUpdateHidden()
	
	-- HPS
	self.combatSessionHPSDisplay = WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_HPS_Display", ZO_ActionBar1, CT_TEXTURE )
	self.combatSessionHPSDisplay:SetDimensions( 121, 20 )
	self.combatSessionHPSDisplay:SetMouseEnabled( true )
	self.combatSessionHPSDisplay:SetMovable( true )
	self.combatSessionHPSDisplay:SetAnchor(
		self.settings.combatSessionHPSDisplayPoint,
		self.settings.combatSessionHPSDisplayRelativeTo,
		self.settings.combatSessionHPSDisplayRelativePoint,
		self.settings.combatSessionHPSDisplayOffsetX,
		self.settings.combatSessionHPSDisplayOffsetY
	)
	
	self.combatSessionHPSDisplay.hps = WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Display_HPS_Label", ZO_ActionBar1, CT_LABEL )
	self.combatSessionHPSDisplay.hps:SetAnchor( CENTER, TCS_Combat_Session_HPS_Display, CENTER, 0, -1 )
	self.combatSessionHPSDisplay.hps:SetText( GetString( _G[ self.localizedStrings.GENERIC_HPS ] ) .. ": 0" )
	
	self:SetCombatSessionHPSUpdateHidden()
	
	-- Total Healing
	self.combatSessionTotalHealingDisplay = WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Total_Healing_Display", ZO_ActionBar1, CT_TEXTURE )
	self.combatSessionTotalHealingDisplay:SetDimensions( 121, 20 )
	self.combatSessionTotalHealingDisplay:SetMouseEnabled( true )
	self.combatSessionTotalHealingDisplay:SetMovable( true )
	self.combatSessionTotalHealingDisplay:SetAnchor(
		self.settings.combatSessionTotalHealingDisplayPoint,
		self.settings.combatSessionTotalHealingDisplayRelativeTo,
		self.settings.combatSessionTotalHealingDisplayRelativePoint,
		self.settings.combatSessionTotalHealingDisplayOffsetX,
		self.settings.combatSessionTotalHealingDisplayOffsetY
	)

	self.combatSessionTotalHealingDisplay.totalHealing = WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Display_Total_Healing_Label", ZO_ActionBar1, CT_LABEL )
	self.combatSessionTotalHealingDisplay.totalHealing:SetAnchor( CENTER, TCS_Combat_Session_Total_Healing_Display, CENTER, 0, -1 )
	self.combatSessionTotalHealingDisplay.totalHealing:SetText( GetString( _G[ self.localizedStrings.SETTINGS_HEAL_TOTAL_SHOW_LABEL ] ) .. ": 0" )
	
	self:SetCombatSessionTotalHealingUpdateHidden()
	
	self:SetCombatSessionDisplayBGType( self.settings.combatSessionDisplayBGType )
	self:SetCombatSessionDisplayBGTransparency( self.settings.combatSessionDisplayBGTransparency )
	self:SetCombatSessionDisplayTextTransparency( self.settings.combatSessionDisplayTextTransparency )

	self:UpdateCombatSessionDisplays()
	
	-- Show action bar when changing settings
	self:RegisterHandler(
		TCS_SettingsMenu_BG_Type_Combat_Session_Display_Dropdown, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_BG_Type_Combat_Session_Display_Dropdown,
		function() ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_BG_Type_Combat_Session_Display_Dropdown, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_BG_Type_Combat_Session_Display_Dropdown,
		function() ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_BG_Type_Combat_Session_Display_DropdownDropdown, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_BG_Type_Combat_Session_Display_DropdownDropdown,
		function() ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_BG_Type_Combat_Session_Display_DropdownDropdown, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_BG_Type_Combat_Session_Display_DropdownDropdown,
		function() ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_Scale_Combat_Session_Display_Slider, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_Scale_Combat_Session_Display_Slider,
		function() ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_Scale_Combat_Session_Display_Slider, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_Scale_Combat_Session_Display_Slider,
		function() ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_Scale_Combat_Session_Display_SliderSlider, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_Scale_Combat_Session_Display_SliderSlider,
		function() ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_Scale_Combat_Session_Display_SliderSlider, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_Scale_Combat_Session_Display_SliderSlider,
		function() ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_BG_Transparency_Combat_Session_Display_Slider, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_BG_Transparency_Combat_Session_Display_Slider,
		function() ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_BG_Transparency_Combat_Session_Display_Slider, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_BG_Transparency_Combat_Session_Display_Slider,
		function() ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_BG_Transparency_Combat_Session_Display_SliderSlider, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_BG_Transparency_Combat_Session_Display_SliderSlider,
		function() ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_BG_Transparency_Combat_Session_Display_SliderSlider, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_BG_Transparency_Combat_Session_Display_SliderSlider,
		function() ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_Text_Transparency_Combat_Session_Display_Slider, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_Text_Transparency_Combat_Session_Display_Slider,
		function() ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_Text_Transparency_Combat_Session_Display_Slider, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_Text_Transparency_Combat_Session_Display_Slider,
		function() ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_Text_Transparency_Combat_Session_Display_SliderSlider, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_Text_Transparency_Combat_Session_Display_SliderSlider,
		function() ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_Text_Transparency_Combat_Session_Display_SliderSlider, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_Text_Transparency_Combat_Session_Display_SliderSlider,
		function() ZO_ActionBar1:SetHidden( true ) end
	)
end

function TCS:SetCombatSessionDisplayFontScale( _scale )
	local scale = _scale
	
	if( scale < 1.0 ) then scale = 1 end
	if( scale > 6.0 ) then scale = 6 end
	
	if( scale == 1 ) then
		self.combatSessionDPSDisplay.dps:SetFont( "ZoFontGameSmall" )
		self.combatSessionTotalDamageDisplay.totalDamage:SetFont( "ZoFontGameSmall" )
		self.combatSessionHPSDisplay.hps:SetFont( "ZoFontGameSmall" )
		self.combatSessionTotalHealingDisplay.totalHealing:SetFont( "ZoFontGameSmall" )
	elseif( scale == 2 ) then
		self.combatSessionDPSDisplay.dps:SetFont( "ZoFontWinT2" )
		self.combatSessionTotalDamageDisplay.totalDamage:SetFont( "ZoFontWinT2" )
		self.combatSessionHPSDisplay.hps:SetFont( "ZoFontWinT2" )
		self.combatSessionTotalHealingDisplay.totalHealing:SetFont( "ZoFontWinT2" )
	elseif( scale == 3 ) then
		self.combatSessionDPSDisplay.dps:SetFont( "ZoFontWinT1" )
		self.combatSessionTotalDamageDisplay.totalDamage:SetFont( "ZoFontWinT1" )
		self.combatSessionHPSDisplay.hps:SetFont( "ZoFontWinT1" )
		self.combatSessionTotalHealingDisplay.totalHealing:SetFont( "ZoFontWinT1" )
	elseif( scale == 4 ) then
		self.combatSessionDPSDisplay.dps:SetFont( "ZoFontWinH3" )
		self.combatSessionTotalDamageDisplay.totalDamage:SetFont( "ZoFontWinH3" )
		self.combatSessionHPSDisplay.hps:SetFont( "ZoFontWinH3" )
		self.combatSessionTotalHealingDisplay.totalHealing:SetFont( "ZoFontWinH3" )
	elseif( scale == 5 ) then
		self.combatSessionDPSDisplay.dps:SetFont( "ZoFontWinH2" )
		self.combatSessionTotalDamageDisplay.totalDamage:SetFont( "ZoFontWinH2" )
		self.combatSessionHPSDisplay.hps:SetFont( "ZoFontWinH2" )
		self.combatSessionTotalHealingDisplay.totalHealing:SetFont( "ZoFontWinH2" )
	elseif( scale == 6 ) then
		self.combatSessionDPSDisplay.dps:SetFont( "ZoFontWinH1" )
		self.combatSessionTotalDamageDisplay.totalDamage:SetFont( "ZoFontWinH1" )
		self.combatSessionHPSDisplay.hps:SetFont( "ZoFontWinH1" )
		self.combatSessionTotalHealingDisplay.totalHealing:SetFont( "ZoFontWinH1" )
	end
end

function TCS:SetCombatSessionDisplayBGScale( _scale )
	-- First set the width then the scale, very important!
	local scale = _scale
	
	if( scale < 1.0 ) then scale = 1 end
	if( scale > 6.0 ) then scale = 6 end
	
	if( scale == 1 ) then
		self.combatSessionDPSDisplay:SetScale( 1 )
		self.combatSessionTotalDamageDisplay:SetScale( 1 )
		self.combatSessionHPSDisplay:SetScale( 1 )
		self.combatSessionTotalHealingDisplay:SetScale( 1 )
	elseif( scale == 2 ) then
		self.combatSessionDPSDisplay:SetScale( 1.1 )
		self.combatSessionTotalDamageDisplay:SetScale( 1.1 )
		self.combatSessionHPSDisplay:SetScale( 1.1 )
		self.combatSessionTotalHealingDisplay:SetScale( 1.1 )
	elseif( scale == 3 ) then
		self.combatSessionDPSDisplay:SetScale( 1.25 )
		self.combatSessionTotalDamageDisplay:SetScale( 1.25 )
		self.combatSessionHPSDisplay:SetScale( 1.25 )
		self.combatSessionTotalHealingDisplay:SetScale( 1.25 )
	elseif( scale == 4 ) then
		self.combatSessionDPSDisplay:SetScale( 1.4 )
		self.combatSessionTotalDamageDisplay:SetScale( 1.4 )
		self.combatSessionHPSDisplay:SetScale( 1.4 )
		self.combatSessionTotalHealingDisplay:SetScale( 1.4 )
	elseif( scale == 5 ) then
		self.combatSessionDPSDisplay:SetScale( 1.65 )
		self.combatSessionTotalDamageDisplay:SetScale( 1.65 )
		self.combatSessionHPSDisplay:SetScale( 1.65 )
		self.combatSessionTotalHealingDisplay:SetScale( 1.65 )
	elseif( scale == 6 ) then
		self.combatSessionDPSDisplay:SetScale( 2.1 )
		self.combatSessionTotalDamageDisplay:SetScale( 2.1 )
		self.combatSessionHPSDisplay:SetScale( 2.1 )
		self.combatSessionTotalHealingDisplay:SetScale( 2.1 )
	end
end

function TCS:SetCombatSessionDisplayBGType( _bgType )
	local bgType = _bgType
	
	if( bgType == "" ) then
		self.settings.combatSessionDisplayBGType = GetString( _G[ self.localizedStrings.SETTINGS_BACKGROUND_TYPE_A ] )
		bgType = self.settings.combatSessionDisplayBGType
	end
	
	if( bgType == GetString( _G[ self.localizedStrings.SETTINGS_BACKGROUND_TYPE_A ] ) ) then
		self.combatSessionDPSDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_a.dds" )
		self.combatSessionTotalDamageDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_a.dds" )
		self.combatSessionHPSDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_a.dds" )
		self.combatSessionTotalHealingDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_a.dds" )
	elseif( bgType == GetString( _G[ self.localizedStrings.SETTINGS_BACKGROUND_TYPE_B ] ) ) then
		self.combatSessionDPSDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_b.dds" )
		self.combatSessionTotalDamageDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_b.dds" )
		self.combatSessionHPSDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_b.dds" )
		self.combatSessionTotalHealingDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_b.dds" )
	elseif( bgType == GetString( _G[ self.localizedStrings.SETTINGS_BACKGROUND_TYPE_NONE ] ) ) then
		self.combatSessionDPSDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_none.dds" )
		self.combatSessionTotalDamageDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_none.dds" )
		self.combatSessionHPSDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_none.dds" )
		self.combatSessionTotalHealingDisplay:SetTexture( "TsCombatStats/Textures/display_bg_type_none.dds" )
	end
end

function TCS:SetCombatSessionDisplayBGTransparency( _transparency )
	local transparency = _transparency / 100
	
	self.combatSessionDPSDisplay:SetAlpha( transparency )
	self.combatSessionTotalDamageDisplay:SetAlpha( transparency )
	self.combatSessionHPSDisplay:SetAlpha( transparency )
	self.combatSessionTotalHealingDisplay:SetAlpha( transparency )
end

function TCS:SetCombatSessionDisplayTextTransparency( _transparency )
	local transparency = _transparency / 100
	
	self.combatSessionDPSDisplay.dps:SetAlpha( transparency )
	self.combatSessionTotalDamageDisplay.totalDamage:SetAlpha( transparency )
	self.combatSessionHPSDisplay.hps:SetAlpha( transparency )
	self.combatSessionTotalHealingDisplay.totalHealing:SetAlpha( transparency )
end

function TCS:HideCombatSessionDisplays( _hide )
	self:SetCombatSessionDPSUpdateHidden( _hide )
	self:SetCombatSessionTotalDamageUpdateHidden( _hide )
	self:SetCombatSessionHPSUpdateHidden( _hide )
	self:SetCombatSessionTotalHealingUpdateHidden( _hide )
end

function TCS:SetCombatSessionDPSUpdateHidden( _hide )
	if( self.combatSessionDPSDisplay == nil ) then return end
	local isHidden = false
	
	if( _hide == true ) then
		isHidden = _hide
	else
		isHidden = not self.settings.showDPS
	end

	self.combatSessionDPSDisplay:SetHidden( isHidden )
	self.combatSessionDPSDisplay.dps:SetHidden( isHidden )
end

function TCS:SetCombatSessionTotalDamageUpdateHidden( _hide )
	if( self.combatSessionTotalDamageDisplay == nil ) then return end
	local isHidden = false
	
	if( _hide == true ) then
		isHidden = _hide
	else
		isHidden = not self.settings.totalDamage
	end
	
	self.combatSessionTotalDamageDisplay:SetHidden( isHidden )
	self.combatSessionTotalDamageDisplay.totalDamage:SetHidden( isHidden )
end

function TCS:SetCombatSessionHPSUpdateHidden( _hide )
	if( self.combatSessionHPSDisplay == nil ) then return end
	local isHidden = false
	
	if( _hide == true ) then
		isHidden = true
	else
		isHidden = not self.settings.showHPS
	end
	
	self.combatSessionHPSDisplay:SetHidden( isHidden )
	self.combatSessionHPSDisplay.hps:SetHidden( isHidden )
end

function TCS:SetCombatSessionTotalHealingUpdateHidden( _hide )
	if( self.combatSessionTotalHealingDisplay == nil ) then return end
	local isHidden = false
	
	if( _hide == true ) then
		isHidden = _hide
	else
		isHidden = not self.settings.totalHealing
	end
	
	self.combatSessionTotalHealingDisplay:SetHidden( isHidden )
	self.combatSessionTotalHealingDisplay.totalHealing:SetHidden( isHidden )
end

function TCS:UpdateCombatSessionDisplays()
	self:SetCombatSessionDisplayFontScale( self.settings.combatSessionDisplayScale )
	
	-- First set the width then the scale, very important!
	local scale = self.settings.combatSessionDisplayScale

	if( self.combatSessionStartTime == 0 ) then self.combatSessionStartTime = GetGameTimeMilliseconds() end
	
	if( self.settings.showDPS ) then
		local currentDPS 	= 0
		local timeElapsed 	= GetGameTimeMilliseconds() - self.combatSessionStartTime
		
		if( timeElapsed ~= 0 ) then
			currentDPS = self.combatSessionDamageDealt / ( timeElapsed / 1000 )
		end

		local text = GetString( _G[ self.localizedStrings.GENERIC_DPS ] ) .. ": " .. tostring( round( currentDPS, 0 ) ) 
		local textWidth = self.combatSessionDPSDisplay.dps:GetStringWidth( text )
		
		if( scale == 1 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 1.022 ) - textWidth ) + 12 )
		elseif( scale == 2 ) then
			textWidth = textWidth + 12
		elseif( scale == 3 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 0.982 ) - textWidth ) + 5 )
		elseif( scale == 4 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 0.966 ) - textWidth ) + 5 )
		elseif( scale == 5 ) then
			textWidth = textWidth + ( math.pow( textWidth, 0.94 ) - textWidth )
		elseif( scale == 6 ) then
			textWidth = textWidth + ( math.pow( textWidth, 0.905 ) - textWidth )
		end
		
		self.combatSessionDPSDisplay.dps:SetText( text )
		self.combatSessionDPSDisplay:SetDimensions( textWidth, 20 )
	end
	
	if( self.settings.showHPS ) then
		local currentHPS 	= 0
		local timeElapsed 	= GetGameTimeMilliseconds() - self.combatSessionStartTime
		
		if( timeElapsed ~= 0 ) then
			currentHPS = self.combatSessionHealingDone / ( timeElapsed / 1000 )
		end
		
		local text = GetString( _G[ self.localizedStrings.GENERIC_HPS ] ) .. ": " .. tostring( round( currentHPS, 0 ) )
		local textWidth = self.combatSessionHPSDisplay.hps:GetStringWidth( text )
		
		if( scale == 1 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 1.022 ) - textWidth ) + 12 )
		elseif( scale == 2 ) then
			textWidth = textWidth + 12
		elseif( scale == 3 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 0.982 ) - textWidth ) + 5 )
		elseif( scale == 4 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 0.966 ) - textWidth ) + 5 )
		elseif( scale == 5 ) then
			textWidth = textWidth + ( math.pow( textWidth, 0.94 ) - textWidth )
		elseif( scale == 6 ) then
			textWidth = textWidth + ( math.pow( textWidth, 0.905 ) - textWidth )
		end
		
		self.combatSessionHPSDisplay.hps:SetText( text )
		self.combatSessionHPSDisplay:SetDimensions( textWidth, 20 )
	end
	
	if( self.settings.totalDamage ) then
		local text = GetString( _G[ self.localizedStrings.SETTINGS_DAMAGE_TOTAL_LABEL ] ) .. ": " .. tostring( round( self.combatSessionDamageDealt, 0 ) )
		local textWidth = self.combatSessionTotalDamageDisplay.totalDamage:GetStringWidth( text )
		
		if( scale == 1 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 1.022 ) - textWidth ) + 12 )
		elseif( scale == 2 ) then
			textWidth = textWidth + 12
		elseif( scale == 3 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 0.982 ) - textWidth ) + 5 )
		elseif( scale == 4 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 0.966 ) - textWidth ) + 5 )
		elseif( scale == 5 ) then
			textWidth = textWidth + ( math.pow( textWidth, 0.94 ) - textWidth )
		elseif( scale == 6 ) then
			textWidth = textWidth + ( math.pow( textWidth, 0.905 ) - textWidth )
		end
		
		self.combatSessionTotalDamageDisplay.totalDamage:SetText( text )
		self.combatSessionTotalDamageDisplay:SetDimensions( textWidth, 20 )
	end
	
	if( self.settings.totalHealing ) then
		local text = GetString( _G[ self.localizedStrings.SETTINGS_HEAL_TOTAL_SHOW_LABEL ] ) .. ": " .. tostring( round( self.combatSessionHealingDone, 0 ) )
		local textWidth = self.combatSessionTotalHealingDisplay.totalHealing:GetStringWidth( text )
		
		if( scale == 1 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 1.022 ) - textWidth ) + 12 )
		elseif( scale == 2 ) then
			textWidth = textWidth + 12
		elseif( scale == 3 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 0.982 ) - textWidth ) + 5 )
		elseif( scale == 4 ) then
			textWidth = textWidth + ( ( math.pow( textWidth, 0.966 ) - textWidth ) + 5 )
		elseif( scale == 5 ) then
			textWidth = textWidth + ( math.pow( textWidth, 0.94 ) - textWidth )
		elseif( scale == 6 ) then
			textWidth = textWidth + ( math.pow( textWidth, 0.905 ) - textWidth )
		end
		
		self.combatSessionTotalHealingDisplay.totalHealing:SetText( text )
		self.combatSessionTotalHealingDisplay:SetDimensions( textWidth, 20 )
	end
	
	self:SetCombatSessionDisplayBGScale( self.settings.combatSessionDisplayScale )
end

----------------------------------
-- Ability Damage Percentages
----------------------------------
function TCS:InitializeAbilityDamagePercentages()
	self.control:RegisterForEvent(
		EVENT_ACTION_SLOT_UPDATED,
		function( _eventCode, _slotNum )
			if( not self.isInCombat and _slotNum > 2 and _slotNum < 9 ) then
				self:ResetAbilityDamagePercentage()
				self:UpdateSlotNameCache()
			end
		end
	)
		
	self:UpdateSlotNameCache()

	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_Percentage1", ActionButton3Button, CT_TEXTURE )
	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_Percentage2", ActionButton4Button, CT_TEXTURE )
	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_Percentage3", ActionButton5Button, CT_TEXTURE )
	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_Percentage4", ActionButton6Button, CT_TEXTURE )
	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_Percentage5", ActionButton7Button, CT_TEXTURE )
	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_Percentage6", ActionButton8Button, CT_TEXTURE )
	
	TCS_Combat_Session_Ability_Damage_Percentage1:SetDrawLayer( 1 )
	TCS_Combat_Session_Ability_Damage_Percentage2:SetDrawLayer( 1 )
	TCS_Combat_Session_Ability_Damage_Percentage3:SetDrawLayer( 1 )
	TCS_Combat_Session_Ability_Damage_Percentage4:SetDrawLayer( 1 )
	TCS_Combat_Session_Ability_Damage_Percentage5:SetDrawLayer( 1 )
	TCS_Combat_Session_Ability_Damage_Percentage6:SetDrawLayer( 1 )
	
	self:UpdateAbilityDamagePercentagesEnabled()
	self:UpdateAbilityDamagePercentagesWidth()
	self:UpdateAbilityDamagePercentagesColor()
	self:UpdateAbilityDamagePercentagesAlignment()
	
	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_PercentageText1", ActionButton3Button, CT_LABEL )
	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_PercentageText2", ActionButton4Button, CT_LABEL )
	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_PercentageText3", ActionButton5Button, CT_LABEL )
	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_PercentageText4", ActionButton6Button, CT_LABEL )
	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_PercentageText5", ActionButton7Button, CT_LABEL )
	WINDOW_MANAGER:CreateControl( "TCS_Combat_Session_Ability_Damage_PercentageText6", ActionButton8Button, CT_LABEL )
	
	TCS_Combat_Session_Ability_Damage_PercentageText1:SetDrawLayer( 2 )
	TCS_Combat_Session_Ability_Damage_PercentageText2:SetDrawLayer( 2 )
	TCS_Combat_Session_Ability_Damage_PercentageText3:SetDrawLayer( 2 )
	TCS_Combat_Session_Ability_Damage_PercentageText4:SetDrawLayer( 2 )
	TCS_Combat_Session_Ability_Damage_PercentageText5:SetDrawLayer( 2 )
	TCS_Combat_Session_Ability_Damage_PercentageText6:SetDrawLayer( 2 )
	
	self:UpdateAbilityDamagePercentagesTextEnabled()
	self:UpdateAbilityDamagePercentagesTextSize()
	self:UpdateAbilityDamagePercentagesTextAlignment()
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Bar_Indicators_Checkbox, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Enable_Bar_Indicators_Checkbox,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Bar_Indicators_Checkbox, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Enable_Bar_Indicators_Checkbox,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Bar_Indicators_CheckboxCheckbox, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Enable_Bar_Indicators_CheckboxCheckbox,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Bar_Indicators_CheckboxCheckbox, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Enable_Bar_Indicators_CheckboxCheckbox,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Width_Slider, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Width_Slider,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Width_Slider, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Width_Slider,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Width_SliderSlider, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Width_SliderSlider,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Width_SliderSlider, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Width_SliderSlider,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Alignment_Dropdown, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Alignment_Dropdown,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Alignment_Dropdown, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Alignment_Dropdown,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Alignment_DropdownDropdown, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Alignment_DropdownDropdown,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Alignment_DropdownDropdown, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Alignment_DropdownDropdown,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Color_Colorpicker, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Color_Colorpicker,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Color_Colorpicker, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Bar_Indicators_Color_Colorpicker,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Percentage_Indicators_Checkbox, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Enable_Percentage_Indicators_Checkbox,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Percentage_Indicators_Checkbox, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Enable_Percentage_Indicators_Checkbox,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Percentage_Indicators_CheckboxCheckbox, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Enable_Percentage_Indicators_CheckboxCheckbox,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Enable_Percentage_Indicators_CheckboxCheckbox, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Enable_Percentage_Indicators_CheckboxCheckbox,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Size_Slider, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Size_Slider,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Size_Slider, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Size_Slider,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Size_SliderSlider, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Size_SliderSlider,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Size_SliderSlider, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Size_SliderSlider,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Alignment_Dropdown, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Alignment_Dropdown,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Alignment_Dropdown, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Alignment_Dropdown,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Alignment_DropdownDropdown, "OnMouseEnter",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Alignment_DropdownDropdown,
		function() self:SetAbilityDamagePercentagesPreview( true ) ZO_ActionBar1:SetHidden( false ) end
	)
	
	self:RegisterHandler(
		TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Alignment_DropdownDropdown, "OnMouseExit",
		self.handlerBackups.TCS_SettingsMenu_AbilityDamagePercentages_Percentage_Indicators_Alignment_DropdownDropdown,
		function() self:SetAbilityDamagePercentagesPreview( false ) ZO_ActionBar1:SetHidden( true ) end
	)
end

_debugSlotNameCache = {}
function TCS:UpdateSlotNameCache()
	local proxy = ""
	local abilityName = ""
	
	-- slot 3
	abilityName = string.lower( string.gsub( GetSlotName( 3 ) , "%^.*", "") )
	proxy 		= self.abilityNameProxies[ abilityName ]
	if( proxy ~= nil ) then abilityName = proxy end
	
	self.slotNameCache[ 3 ] = abilityName
	
	
	-- slot 4
	abilityName = string.lower( string.gsub( GetSlotName( 4 ) , "%^.*", "") )
	proxy 		= self.abilityNameProxies[ abilityName ]
	if( proxy ~= nil ) then abilityName = proxy end
	
	self.slotNameCache[ 4 ] = abilityName
	
	-- slot 5
	abilityName = string.lower( string.gsub( GetSlotName( 5 ) , "%^.*", "") )
	proxy 		= self.abilityNameProxies[ abilityName ]
	if( proxy ~= nil ) then abilityName = proxy end
	
	self.slotNameCache[ 5 ] = abilityName
	
	-- slot 6
	abilityName = string.lower( string.gsub( GetSlotName( 6 ) , "%^.*", "") )
	proxy 		= self.abilityNameProxies[ abilityName ]
	if( proxy ~= nil ) then abilityName = proxy end
	
	self.slotNameCache[ 6 ] = abilityName
	
	-- slot 7
	abilityName = string.lower( string.gsub( GetSlotName( 7 ) , "%^.*", "") )
	proxy 		= self.abilityNameProxies[ abilityName ]
	if( proxy ~= nil ) then abilityName = proxy end
	
	self.slotNameCache[ 7 ] = abilityName
	
	-- slot 8
	abilityName = string.lower( string.gsub( GetSlotName( 8 ) , "%^.*", "") )
	proxy 		= self.abilityNameProxies[ abilityName ]
	if( proxy ~= nil ) then abilityName = proxy end
	
	self.slotNameCache[ 8 ] = abilityName
	
	_debugSlotNameCache = self.slotNameCache
end

function TCS:UpdateAbilityDamagePercentagesEnabled()
	local enabled = self.settings.combatSessionAbilityDamageEnableBarIndicators
	
	TCS_Combat_Session_Ability_Damage_Percentage1:SetHidden( not enabled )
	TCS_Combat_Session_Ability_Damage_Percentage2:SetHidden( not enabled )
	TCS_Combat_Session_Ability_Damage_Percentage3:SetHidden( not enabled )
	TCS_Combat_Session_Ability_Damage_Percentage4:SetHidden( not enabled )
	TCS_Combat_Session_Ability_Damage_Percentage5:SetHidden( not enabled )
	TCS_Combat_Session_Ability_Damage_Percentage6:SetHidden( not enabled )
end

function TCS:UpdateAbilityDamagePercentagesWidth( _preview )
	local slotWidth = ( ActionButton3Button:GetWidth() - 4 ) * ( self.settings.combatSessionAbilityDamageBarWidth / 100 )
	local slotHeight = 0
	
	if( _preview ) then slotHeight = ActionButton3Button:GetHeight() - 4 end
	
	TCS_Combat_Session_Ability_Damage_Percentage1:SetDimensions( slotWidth, slotHeight )
	TCS_Combat_Session_Ability_Damage_Percentage2:SetDimensions( slotWidth, slotHeight )
	TCS_Combat_Session_Ability_Damage_Percentage3:SetDimensions( slotWidth, slotHeight )
	TCS_Combat_Session_Ability_Damage_Percentage4:SetDimensions( slotWidth, slotHeight )
	TCS_Combat_Session_Ability_Damage_Percentage5:SetDimensions( slotWidth, slotHeight )
	TCS_Combat_Session_Ability_Damage_Percentage6:SetDimensions( slotWidth, slotHeight )
end

function TCS:UpdateAbilityDamagePercentagesColor()
	local r = self.settings.combatSessionAbilityDamageBarR
	local g = self.settings.combatSessionAbilityDamageBarG
	local b = self.settings.combatSessionAbilityDamageBarB
	local a = 0.75
	
	TCS_Combat_Session_Ability_Damage_Percentage1:SetColor( r, g, b, a )
	TCS_Combat_Session_Ability_Damage_Percentage2:SetColor( r, g, b, a )
	TCS_Combat_Session_Ability_Damage_Percentage3:SetColor( r, g, b, a )
	TCS_Combat_Session_Ability_Damage_Percentage4:SetColor( r, g, b, a )
	TCS_Combat_Session_Ability_Damage_Percentage5:SetColor( r, g, b, a )
	TCS_Combat_Session_Ability_Damage_Percentage6:SetColor( r, g, b, a )
end

function TCS:UpdateAbilityDamagePercentagesAlignment()
	local alignment = self.settings.combatSessionAbilityDamageBarAlignment
	local offsetX = 2
	local offsetY = -2
	
	TCS_Combat_Session_Ability_Damage_Percentage1:ClearAnchors()
	TCS_Combat_Session_Ability_Damage_Percentage2:ClearAnchors()
	TCS_Combat_Session_Ability_Damage_Percentage3:ClearAnchors()
	TCS_Combat_Session_Ability_Damage_Percentage4:ClearAnchors()
	TCS_Combat_Session_Ability_Damage_Percentage5:ClearAnchors()
	TCS_Combat_Session_Ability_Damage_Percentage6:ClearAnchors()
		
	if( alignment == GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_ALIGNMENT_LEFT ] ) ) then
		TCS_Combat_Session_Ability_Damage_Percentage1:SetAnchor( BOTTOMLEFT, ActionButton3, BOTTOMLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_Percentage2:SetAnchor( BOTTOMLEFT, ActionButton4, BOTTOMLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_Percentage3:SetAnchor( BOTTOMLEFT, ActionButton5, BOTTOMLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_Percentage4:SetAnchor( BOTTOMLEFT, ActionButton6, BOTTOMLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_Percentage5:SetAnchor( BOTTOMLEFT, ActionButton7, BOTTOMLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_Percentage6:SetAnchor( BOTTOMLEFT, ActionButton8, BOTTOMLEFT, offsetX, offsetY )
	elseif( alignment == GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_BAR_ALIGNMENT_RIGHT ] ) ) then
		TCS_Combat_Session_Ability_Damage_Percentage1:SetAnchor( BOTTOMRIGHT, ActionButton3, BOTTOMRIGHT, offsetX * -1, offsetY )
		TCS_Combat_Session_Ability_Damage_Percentage2:SetAnchor( BOTTOMRIGHT, ActionButton4, BOTTOMRIGHT, offsetX * -1, offsetY )
		TCS_Combat_Session_Ability_Damage_Percentage3:SetAnchor( BOTTOMRIGHT, ActionButton5, BOTTOMRIGHT, offsetX * -1, offsetY )
		TCS_Combat_Session_Ability_Damage_Percentage4:SetAnchor( BOTTOMRIGHT, ActionButton6, BOTTOMRIGHT, offsetX * -1, offsetY )
		TCS_Combat_Session_Ability_Damage_Percentage5:SetAnchor( BOTTOMRIGHT, ActionButton7, BOTTOMRIGHT, offsetX * -1, offsetY )
		TCS_Combat_Session_Ability_Damage_Percentage6:SetAnchor( BOTTOMRIGHT, ActionButton8, BOTTOMRIGHT, offsetX * -1, offsetY )
	end
end

function TCS:UpdateAbilityDamagePercentagesTextEnabled()
	local enabled = self.settings.combatSessionAbilityDamageEnablePercentage
	
	if( ActionButton3Button.actionId ~= 0 ) then
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetHidden( not enabled )
	else
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetHidden( true )
	end
	
	if( ActionButton4Button.actionId ~= 0 ) then
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetHidden( not enabled )
	else
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetHidden( true )
	end
	
	if( ActionButton5Button.actionId ~= 0 ) then
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetHidden( not enabled )
	else
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetHidden( true )
	end
	
	if( ActionButton6Button.actionId ~= 0 ) then
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetHidden( not enabled )
	else
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetHidden( true )
	end
	
	if( ActionButton7Button.actionId ~= 0 ) then
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetHidden( not enabled )
	else
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetHidden( true )
	end
	
	if( ActionButton8Button.actionId ~= 0 ) then
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetHidden( not enabled )
	else
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetHidden( true )
	end
end

function TCS:UpdateAbilityDamagePercentagesTextSize()
	local size = self.settings.combatSessionAbilityDamagePercentageSize
	
	if( size < 1 ) then size = 1 end
	if( size > 4 ) then size = 4 end
	
	if( size == 1 ) then
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetFont( "ZoFontGameSmall" )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetFont( "ZoFontGameSmall" )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetFont( "ZoFontGameSmall" )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetFont( "ZoFontGameSmall" )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetFont( "ZoFontGameSmall" )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetFont( "ZoFontGameSmall" )
	elseif( size == 2 ) then
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetFont( "ZoFontWinT2" )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetFont( "ZoFontWinT2" )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetFont( "ZoFontWinT2" )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetFont( "ZoFontWinT2" )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetFont( "ZoFontWinT2" )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetFont( "ZoFontWinT2" )
	elseif( size == 3 ) then
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetFont( "ZoFontWinT1" )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetFont( "ZoFontWinT1" )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetFont( "ZoFontWinT1" )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetFont( "ZoFontWinT1" )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetFont( "ZoFontWinT1" )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetFont( "ZoFontWinT1" )
	elseif( size == 4 ) then
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetFont( "ZoFontWinH3" )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetFont( "ZoFontWinH3" )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetFont( "ZoFontWinH3" )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetFont( "ZoFontWinH3" )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetFont( "ZoFontWinH3" )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetFont( "ZoFontWinH3" )
	end
end

function TCS:UpdateAbilityDamagePercentagesTextAlignment()
	local alignment = self.settings.combatSessionAbilityDamagePercentageAlignment
	
	TCS_Combat_Session_Ability_Damage_PercentageText1:ClearAnchors()
	TCS_Combat_Session_Ability_Damage_PercentageText2:ClearAnchors()
	TCS_Combat_Session_Ability_Damage_PercentageText3:ClearAnchors()
	TCS_Combat_Session_Ability_Damage_PercentageText4:ClearAnchors()
	TCS_Combat_Session_Ability_Damage_PercentageText5:ClearAnchors()
	TCS_Combat_Session_Ability_Damage_PercentageText6:ClearAnchors()
	
	if( alignment == GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_CENTER ] ) ) then
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetAnchor( CENTER, ActionButton3, CENTER, 0, 0 )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetAnchor( CENTER, ActionButton4, CENTER, 0, 0 )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetAnchor( CENTER, ActionButton5, CENTER, 0, 0 )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetAnchor( CENTER, ActionButton6, CENTER, 0, 0 )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetAnchor( CENTER, ActionButton7, CENTER, 0, 0 )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetAnchor( CENTER, ActionButton8, CENTER, 0, 0 )
	elseif( alignment == GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_LEFT ] ) ) then
		local offsetX = 4
		local offsetY = 0
	
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetAnchor( LEFT, ActionButton3, LEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetAnchor( LEFT, ActionButton4, LEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetAnchor( LEFT, ActionButton5, LEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetAnchor( LEFT, ActionButton6, LEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetAnchor( LEFT, ActionButton7, LEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetAnchor( LEFT, ActionButton8, LEFT, offsetX, offsetY )
	elseif( alignment == GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_RIGHT ] ) ) then
		local offsetX = -4
		local offsetY = 0
		
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetAnchor( RIGHT, ActionButton3, RIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetAnchor( RIGHT, ActionButton4, RIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetAnchor( RIGHT, ActionButton5, RIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetAnchor( RIGHT, ActionButton6, RIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetAnchor( RIGHT, ActionButton7, RIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetAnchor( RIGHT, ActionButton8, RIGHT, offsetX, offsetY )
	elseif( alignment == GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOMLEFT ] ) ) then
		local offsetX = 4
		local offsetY = 0
	
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetAnchor( BOTTOMLEFT, ActionButton3, BOTTOMLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetAnchor( BOTTOMLEFT, ActionButton4, BOTTOMLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetAnchor( BOTTOMLEFT, ActionButton5, BOTTOMLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetAnchor( BOTTOMLEFT, ActionButton6, BOTTOMLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetAnchor( BOTTOMLEFT, ActionButton7, BOTTOMLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetAnchor( BOTTOMLEFT, ActionButton8, BOTTOMLEFT, offsetX, offsetY )
	elseif( alignment == GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOMRIGHT ] ) ) then
		local offsetX = -4
		local offsetY = 0
		
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetAnchor( BOTTOMRIGHT, ActionButton3, BOTTOMRIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetAnchor( BOTTOMRIGHT, ActionButton4, BOTTOMRIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetAnchor( BOTTOMRIGHT, ActionButton5, BOTTOMRIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetAnchor( BOTTOMRIGHT, ActionButton6, BOTTOMRIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetAnchor( BOTTOMRIGHT, ActionButton7, BOTTOMRIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetAnchor( BOTTOMRIGHT, ActionButton8, BOTTOMRIGHT, offsetX, offsetY )
	elseif( alignment == GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOPLEFT ] ) ) then
		local offsetX = 4
		local offsetY = 0
	
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetAnchor( TOPLEFT, ActionButton3, TOPLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetAnchor( TOPLEFT, ActionButton4, TOPLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetAnchor( TOPLEFT, ActionButton5, TOPLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetAnchor( TOPLEFT, ActionButton6, TOPLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetAnchor( TOPLEFT, ActionButton7, TOPLEFT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetAnchor( TOPLEFT, ActionButton8, TOPLEFT, offsetX, offsetY )
	elseif( alignment == GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOPRIGHT ] ) ) then
		local offsetX = -4
		local offsetY = 0
		
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetAnchor( TOPRIGHT, ActionButton3, TOPRIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetAnchor( TOPRIGHT, ActionButton4, TOPRIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetAnchor( TOPRIGHT, ActionButton5, TOPRIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetAnchor( TOPRIGHT, ActionButton6, TOPRIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetAnchor( TOPRIGHT, ActionButton7, TOPRIGHT, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetAnchor( TOPRIGHT, ActionButton8, TOPRIGHT, offsetX, offsetY )
	elseif( alignment == GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_BOTTOM ] ) ) then
		local offsetX = 0
		local offsetY = 0
	
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetAnchor( BOTTOM, ActionButton3, BOTTOM, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetAnchor( BOTTOM, ActionButton4, BOTTOM, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetAnchor( BOTTOM, ActionButton5, BOTTOM, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetAnchor( BOTTOM, ActionButton6, BOTTOM, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetAnchor( BOTTOM, ActionButton7, BOTTOM, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetAnchor( BOTTOM, ActionButton8, BOTTOM, offsetX, offsetY )
	elseif( alignment == GetString( _G[ self.localizedStrings.SETTINGS_ABILITY_DAMAGE_PERCENTAGES_TEXT_ALIGNMENT_TOP ] ) ) then
		local offsetX = 0
		local offsetY = 0
		
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetAnchor( TOP, ActionButton3, TOP, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetAnchor( TOP, ActionButton4, TOP, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetAnchor( TOP, ActionButton5, TOP, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetAnchor( TOP, ActionButton6, TOP, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetAnchor( TOP, ActionButton7, TOP, offsetX, offsetY )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetAnchor( TOP, ActionButton8, TOP, offsetX, offsetY )
	end
end

function TCS:UpdateAbilityDamagePercentage( _abilityName, _damage )
	if( self.combatSessionAbilityDamage[ self.slotNameCache[ 3 ] ] == nil ) then self.combatSessionAbilityDamage[ self.slotNameCache[ 3 ] ] = 0 end
	if( self.combatSessionAbilityDamage[ self.slotNameCache[ 4 ] ] == nil ) then self.combatSessionAbilityDamage[ self.slotNameCache[ 4 ] ] = 0 end
	if( self.combatSessionAbilityDamage[ self.slotNameCache[ 5 ] ] == nil ) then self.combatSessionAbilityDamage[ self.slotNameCache[ 5 ] ] = 0 end
	if( self.combatSessionAbilityDamage[ self.slotNameCache[ 6 ] ] == nil ) then self.combatSessionAbilityDamage[ self.slotNameCache[ 6 ] ] = 0 end
	if( self.combatSessionAbilityDamage[ self.slotNameCache[ 7 ] ] == nil ) then self.combatSessionAbilityDamage[ self.slotNameCache[ 7 ] ] = 0 end
	if( self.combatSessionAbilityDamage[ self.slotNameCache[ 8 ] ] == nil ) then self.combatSessionAbilityDamage[ self.slotNameCache[ 8 ] ] = 0 end

	local abilityName = string.lower( string.gsub( _abilityName, "%^.*", "") )
	local proxy = self.abilityNameProxies[ abilityName ]
	if( proxy ~= nil ) then abilityName = proxy end

	if( self.combatSessionAbilityDamage[ abilityName ] == nil ) then return end

	self.combatSessionAbilityDamage[ abilityName ] = self.combatSessionAbilityDamage[ abilityName ] + _damage

	local slotHeight = ActionButton3Button:GetHeight() - 4
	local totalDamage = self.combatSessionDamageDealt
	local heighestDamage = 0

	for i = 3, 8, 1 do
		local abilityDamage = self.combatSessionAbilityDamage[ self.slotNameCache[ i ] ]
		if( abilityDamage ~= nil and abilityDamage > 0 and abilityDamage > heighestDamage ) then
			heighestDamage = abilityDamage
		end
	end

	local slot1Percentage = round( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 3 ] ] / totalDamage ) * 100, 0 )
	local slot2Percentage = round( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 4 ] ] / totalDamage ) * 100, 0 )
	local slot3Percentage = round( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 5 ] ] / totalDamage ) * 100, 0 )
	local slot4Percentage = round( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 6 ] ] / totalDamage ) * 100, 0 )
	local slot5Percentage = round( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 7 ] ] / totalDamage ) * 100, 0 )
	local slot6Percentage = round( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 8 ] ] / totalDamage ) * 100, 0 )
	
	if( slot1Percentage > 0 ) then
		TCS_Combat_Session_Ability_Damage_Percentage1:SetHeight( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 3 ] ] / heighestDamage ) * slotHeight )
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetText( slot1Percentage .. "%" )
	else
		TCS_Combat_Session_Ability_Damage_Percentage1:SetHeight( 0 )
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetText( "" )
	end
	
	if( slot2Percentage > 0 ) then
		TCS_Combat_Session_Ability_Damage_Percentage2:SetHeight( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 4 ] ] / heighestDamage ) * slotHeight )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetText( slot2Percentage .. "%" )
	else
		TCS_Combat_Session_Ability_Damage_Percentage2:SetHeight( 0 )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetText( "" )
	end
	
	if( slot3Percentage > 0 ) then
		TCS_Combat_Session_Ability_Damage_Percentage3:SetHeight( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 5 ] ] / heighestDamage ) * slotHeight )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetText( slot3Percentage .. "%" )
	else
		TCS_Combat_Session_Ability_Damage_Percentage3:SetHeight( 0 )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetText( "" )
	end
	
	if( slot4Percentage > 0 ) then
		TCS_Combat_Session_Ability_Damage_Percentage4:SetHeight( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 6 ] ] / heighestDamage ) * slotHeight )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetText( slot4Percentage .. "%" )
	else
		TCS_Combat_Session_Ability_Damage_Percentage4:SetHeight( 0 )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetText( "" )
	end
	
	if( slot5Percentage > 0 ) then
		TCS_Combat_Session_Ability_Damage_Percentage5:SetHeight( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 7 ] ] / heighestDamage ) * slotHeight )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetText( slot5Percentage .. "%" )
	else
		TCS_Combat_Session_Ability_Damage_Percentage5:SetHeight( 0 )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetText( "" )
	end
	
	if( slot6Percentage > 0 ) then
		TCS_Combat_Session_Ability_Damage_Percentage6:SetHeight( ( self.combatSessionAbilityDamage[ self.slotNameCache[ 8 ] ] / heighestDamage ) * slotHeight )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetText( slot6Percentage .. "%" )
	else
		TCS_Combat_Session_Ability_Damage_Percentage6:SetHeight( 0 )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetText( "" )
	end
end

function TCS:ResetAbilityDamagePercentage()
	self.combatSessionAbilityDamage = {}
	
	TCS_Combat_Session_Ability_Damage_Percentage1:SetHeight( 0 )
	TCS_Combat_Session_Ability_Damage_PercentageText1:SetText( "" )
	
	TCS_Combat_Session_Ability_Damage_Percentage2:SetHeight( 0 )
	TCS_Combat_Session_Ability_Damage_PercentageText2:SetText( "" )
	
	TCS_Combat_Session_Ability_Damage_Percentage3:SetHeight( 0 )
	TCS_Combat_Session_Ability_Damage_PercentageText3:SetText( "" )
	
	TCS_Combat_Session_Ability_Damage_Percentage4:SetHeight( 0 )
	TCS_Combat_Session_Ability_Damage_PercentageText4:SetText( "" )
	
	TCS_Combat_Session_Ability_Damage_Percentage5:SetHeight( 0 )
	TCS_Combat_Session_Ability_Damage_PercentageText5:SetText( "" )
	
	TCS_Combat_Session_Ability_Damage_Percentage6:SetHeight( 0 )
	TCS_Combat_Session_Ability_Damage_PercentageText6:SetText( "" )
end

function TCS:SetAbilityDamagePercentagesPreview( _preview )
	if( _preview ) then
		TCS_Combat_Session_Ability_Damage_Percentage1:SetHidden( false )
		TCS_Combat_Session_Ability_Damage_Percentage2:SetHidden( false )
		TCS_Combat_Session_Ability_Damage_Percentage3:SetHidden( false )
		TCS_Combat_Session_Ability_Damage_Percentage4:SetHidden( false )
		TCS_Combat_Session_Ability_Damage_Percentage5:SetHidden( false )
		TCS_Combat_Session_Ability_Damage_Percentage6:SetHidden( false )
		
		TCS_Combat_Session_Ability_Damage_Percentage1:SetHeight( ActionButton3Button:GetHeight() - 4 )
		TCS_Combat_Session_Ability_Damage_Percentage2:SetHeight( ActionButton3Button:GetHeight() - 4 )
		TCS_Combat_Session_Ability_Damage_Percentage3:SetHeight( ActionButton3Button:GetHeight() - 4 )
		TCS_Combat_Session_Ability_Damage_Percentage4:SetHeight( ActionButton3Button:GetHeight() - 4 )
		TCS_Combat_Session_Ability_Damage_Percentage5:SetHeight( ActionButton3Button:GetHeight() - 4 )
		TCS_Combat_Session_Ability_Damage_Percentage6:SetHeight( ActionButton3Button:GetHeight() - 4 )
		
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetHidden( false )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetHidden( false )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetHidden( false )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetHidden( false )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetHidden( false )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetHidden( false )
		
		TCS_Combat_Session_Ability_Damage_PercentageText1:SetText( "100%" )
		TCS_Combat_Session_Ability_Damage_PercentageText2:SetText( "100%" )
		TCS_Combat_Session_Ability_Damage_PercentageText3:SetText( "100%" )
		TCS_Combat_Session_Ability_Damage_PercentageText4:SetText( "100%" )
		TCS_Combat_Session_Ability_Damage_PercentageText5:SetText( "100%" )
		TCS_Combat_Session_Ability_Damage_PercentageText6:SetText( "100%" )
	else
		self:UpdateAbilityDamagePercentagesEnabled()
		self:UpdateAbilityDamagePercentagesWidth()
		self:UpdateAbilityDamagePercentagesColor()
		self:UpdateAbilityDamagePercentagesAlignment()
		self:UpdateAbilityDamagePercentagesTextEnabled()
		self:UpdateAbilityDamagePercentagesTextSize()
		self:UpdateAbilityDamagePercentagesTextAlignment()
		self:ResetAbilityDamagePercentage()
	end
end